var Ajuste_Controller = function(ScreenService, ZhLayoutPreferences, General, templateManager, EstUtil, Ajuste_Service, ZHPromise, ValidacoesEstoque_Service, maskEngine, ZhUtil, metaDataFactory, Lib00206_InfComplProduto_Controller, restEngine, ZhFilterPreferences, MessageService) {
    let self = this;
    let bkpDatasourceFilter = [];
    let ignoredCloneKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    let almoxarifeFilter;
    let localEstoqueFilter;
    let glossary;

    this.validaFilial = true;

    let filutlote = 'N';

    Array.prototype.move = function(old_index, new_index) {
        if (new_index >= this.length) {
            var k = new_index - this.length;
            while ((k--) + 1) {
                this.push(undefined);
            }
        }
        this.splice(new_index, 0, this.splice(old_index, 1)[0]);
    };

    this.openFilter = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(success => {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;

            ZhFilterPreferences.openFilterWidget(widget, rowsToSet).then(filtro => {
                this.validaFilialControlaAlmoxarifado();
            });
        });
    };

    this.validaFilialControlaAlmoxarifado = function() {
        var filtroWidget = templateManager.container.getActiveWidget();

        var cdfilial = filtroWidget.getField('CDFILIAL').value();

        Ajuste_Service.retornaParamUnidade(cdfilial).then(function(paramfilial) {

            var filial = paramfilial.dataset.paramfilial[0];
            let filtroRow = filtroWidget.currentRow;
            const container = filtroWidget.getParent();
            const defaultFields = [];
            delete filial.CDOPERADOR;
            delete filial.CDALMOXARIFE;
            delete filial.CDLOCALESTOQ;

            Object.keys(filial).forEach(key => {
                if (container.name == 'est41000_ajuste_inventario') {
                    if (key != 'CDOPERADOR')
                        if (key != 'CDALMOXARIFE')
                            if (key != 'CDLOCALESTOQ')
                                filtroRow[key] = filial[key] ? filial[key] : filtroRow[key];
                }
                else if (container.name == 'est42000_implantacao_estoque') {
                    if (defaultFields.includes(key))
                        filtroRow[key] = key == 'CDOPERADOR' ? '' : '';
                    else
                        filtroRow[key] = filial[key] ? filial[key] : filtroRow[key];
                }
            });

            sessionStorage.setItem('IDUTILALMOX', filial.IDUTILALMOX);
            sessionStorage.setItem('IDUTILLCESTQ', filial.IDUTILLCESTQ);
            sessionStorage.setItem('IDUTILLOTE', filial.IDUTILLOTE);
            sessionStorage.setItem('FILIAL_CTRLESTQE', filial.IDCTRLESTQ);
            filutlote = filial.IDUTILLOTE == 'S' ? 'S' : 'N';

            if (filtroWidget.getField('DSALMOXARIFE')) {
                if (filial.IDUTILALMOX == 'S') {
                    filtroWidget.getField('DSALMOXARIFE').isVisible = true;
                }
                else {
                    filtroWidget.getField('DSALMOXARIFE').isVisible = false;
                }

                if (filial.IDUTILLCESTQ == 'S') {
                    filtroWidget.getField('DSLOCALESTOQ').isVisible = true;
                }
                else {
                    filtroWidget.getField('DSLOCALESTOQ').isVisible = false;
                }
                filtroWidget.getField('DSALMOXARIFE').reload();
            }
            filtroWidget.reload();

        });
    };

    this.getFilialLogada = function() {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };

    this.setFieldsGerais = function(widget) {
        templateManager.container.fieldsGerais = widget.fields.map(function(field) { return field.name; });
    };

    //Função que ajusta casas decimais de valor unitario de acordo com o parametro
    //Desativada por enquanto até futura definição
    this.ajustaCasasDecimais = function() {
        var produtosWidget = getProdutosWidget();
        var fieldVrLiq = produtosWidget.getField('VRUNILANCTO');
        var fieldVrBrut = produtosWidget.getField('VRUNITBRUT');
        /* General.callRestEngine('df#/crud/paramgeral', 'FilterData', []).then(function(success) {
             if(success.dataset.paramgeral[0]){
                 var paramgeral = success.dataset.paramgeral[0];
                 fieldVrLiq.mask.params.precision = paramgeral.NRDECITOTANF;
                 fieldVrBrut.mask.params.precision = paramgeral.NRDECITOTANF;
             }
         });*/
    };

    var getProdutosWidget = function() {
        return templateManager.container.getWidget("Produtos");
    };

    this.openLibPopup = function(widget) {
        let arrAllowedTypes = ['inline_edit', 'list'];
        if (!arrAllowedTypes.some(type => type == widget.mode))
            widget.getField('QTTOTLANCTO').readOnly = true;

        if (widget.currentRow.CDARVPROD) {
            Lib00206_InfComplProduto_Controller.infComplementares(widget, widget.currentRow);
        }
        else {
            widget.currentRow.QTTOTLANCTO = null;
        }
    };
    
    this.posicaoVisibility = function(widget) {
        if(widget.currentRow.NMPRODUTO)        
            widget.getAction('viewstock').isVisible = true;
        else
            widget.getAction('viewstock').isVisible = false;
            
        widget.redraw();
    };

    this.openImportPopup = function(widget) {
        var popup = this.createImportPopup(widget);
        ScreenService.openPopup(popup);
    };

    this.setFiliMovi = function(widget) {
        var filiMovi = widget.appliedFilter.FILTER_ROW.CDFILIAL;
        almoxarifeFilter = widget.appliedFilter.FILTER_ROW.CDALMOXARIFE;
        localEstoqueFilter = widget.appliedFilter.FILTER_ROW.CDLOCALESTOQ;

        widget.currentRow.CDFILIMOVI = filiMovi;

        if (sessionStorage.getItem('FILIAL_CTRLESTQE') == 'N') {
            ScreenService.showMessage('Filial não controla Estoque.');

            widget.getAction('Novo').isVisible = false;
            widget.getAction('importTxt').isVisible = false;
            widget.reload();
        }
        else {
            widget.getAction('Novo').isVisible = true;
            widget.getAction('importTxt').isVisible = true;
            widget.reload();
        }
    };

    this.createImportPopup = function(parentWidget) {
        var popup = parentWidget.importPopup;

        if (!popup) {
            popup = this.getPopupObject();
            popup.container = parentWidget.container;
            popup = metaDataFactory.widgetFactory(popup, parentWidget);
            parentWidget.importPopup = popup;
            popup.parent = parentWidget;
            popup.currentRow.CDORDENA = "C";
            popup.currentRow.IDGRUPPROD = "P";
            popup.currentRow.AJUSTEPOR = "P";
        }

        return popup;
    };

    this.importSwipeManager = function(action, widget = null) {
        const tabbedWidget = templateManager.container.getWidget('tabImportWidget');
        const widgetErrors = templateManager.container.getWidget('errorsWidget');

        if (action === 'onOpen') {
            let isAjuste = widget.name === 'est41000_ajusteInventario' ? true : false;

            this.onManageXlsModelFields(isAjuste).then(() => {
                ScreenService.openSwipe(tabbedWidget).then(() => {
                    if (widgetErrors.dataSource.data.length != 0) widgetErrors.dataSource.data = [];
                });

            });
        }
        else {
            widgetErrors.dataSource.data.pop();
            ScreenService.closeSwipe();
        }
    };

    this.getPopupObject = function() {
        return {
            "isVisible": true,
            "name": "importPopup",
            "label": "Importação de Produtos por Grupo",
            "template": "widget/form.html",
            "actions": [{
                    "name": "cancel",
                    "label": "Cancelar",
                    "showAsAction": "back",
                    "isVisible": true,
                    "events": [{
                        "name": "ActionEvent",
                        "code": "ScreenService.closePopup()"
                    }]
                },
                {
                    "name": "confirmAction",
                    "label": "Confirmar",
                    "showAsAction": "never",
                    "isVisible": true,
                    "events": [{
                        "name": "ActionEvent",
                        "code": "Ajuste_Controller.importProducts(args.owner.widget)"
                    }]
                }
            ],
            "fields": [{
                    "name": "AJUSTEPOR",
                    "label": "Agrupamento por",
                    "template": "field/select-native.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 3,
                    "hideEmptyValue": true,
                    "defaultValue": "P",
                    "dataSource": {
                        "data": [{
                                "IDAJUSTEPOR": "P",
                                "AJUSTEPOR": "Produto"
                            },
                            {
                                "IDAJUSTEPOR": "U",
                                "AJUSTEPOR": "Unidade"
                            },
                            {
                                "IDAJUSTEPOR": "E",
                                "AJUSTEPOR": "Posição de Estoque"
                            }
                        ]
                    },
                    "descriptionField": "AJUSTEPOR",
                    "valueField": "IDAJUSTEPOR",
                    "outData": {
                        "AJUSTEPOR": "AJUSTEPOR",
                        "IDAJUSTEPOR": "IDAJUSTEPOR"
                    },
                    "validations": {
                        "required": "Campo Obrigatório"
                    },
                    "events": [{
                        "name": "FieldOnChange",
                        "code": "Ajuste_Controller.habilitaCamposImportacao(args.owner.field.widget)"
                    }]
                },
                {
                    "name": "IDGRUPPROD",
                    "label": "Origem",
                    "template": "field/select-native.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 2,
                    "hideEmptyValue": true,
                    "defaultValue": "P",
                    "dataSource": {
                        "data": [{
                                "IDGRUPPROD": "P",
                                "DSGRUPPROD": "Padrão"
                            },
                            {
                                "IDGRUPPROD": "F",
                                "DSGRUPPROD": "Unidade"
                            }
                        ]
                    },
                    "descriptionField": "DSGRUPPROD",
                    "valueField": "IDGRUPPROD",
                    "outData": {
                        "IDGRUPPROD": "IDGRUPPROD",
                        "DSGRUPPROD": "DSGRUPPROD"
                    },
                    "validations": {
                        "required": "Campo Obrigatório"
                    },
                    "events": []
                },
                {
                    "name": "CDORDENA",
                    "label": "Ordenar Por",
                    "template": "field/select-native.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 2,
                    "hideEmptyValue": true,
                    "dataSource": {
                        "data": [{
                                "CDORDENA": "C",
                                "NMORDENA": "Código"
                            },
                            {
                                "CDORDENA": "N",
                                "NMORDENA": "Nome"
                            }
                        ]
                    },
                    "defaultValue": "C",
                    "descriptionField": "NMORDENA",
                    "valueField": "CDORDENA",
                    "outData": {
                        "CDORDENA": "CDORDENA",
                        "NMORDENA": "NMORDENA"
                    },
                    "validations": {
                        "required": "Campo Obrigatório"
                    },
                    "events": []
                },
                {
                    "name": "NMGRUPPROD",
                    "label": "Agrupamento de Produtos",
                    "template": "field/select.html",
                    "isVisible": true,
                    "showOnForm": true,
                    "showOnList": true,
                    "class": 5,
                    "showSelectAs": "grid",
                    "dataSource": {
                        "rest": true,
                        "name": "est_ajuste#/crud/grupprod_ajuste"
                    },
                    "descriptionField": "NMGRUPPROD",
                    "valueField": "CDGRUPPROD",
                    "outData": {
                        "CDGRUPPROD": "CDGRUPPROD",
                        "NMGRUPPROD": "NMGRUPPROD"
                    },
                    "order": "CDGRUPPROD",
                    "validations": {
                        "required": "Campo Obrigatório"
                    },
                    "fields": [{
                            "label": "Código",
                            "name": "CDGRUPPROD",
                            "showOnList": true
                        },
                        {
                            "label": "Agrupamento",
                            "name": "NMGRUPPROD",
                            "showOnList": true
                        }
                    ],
                    "events": []
                }
            ],
            "widgets": []
        };
    };

    this.setAjusteImportTxt = function(widget) {
        widget.currentRow.DSLANCESTQ = "Lançamento realizado por importação";
        return Ajuste_Service.getOperadorLogado().then((operador) => {
            widget.currentRow.NMOPERADOR = operador[0].NMOPERADOR;
            widget.currentRow.CDOPERADOR = operador[0].CDOPERADOR;
            widget.currentRow.CDFILIAL = operador[0].CDFILIALSELECIONADA;
            widget.currentRow.CDFILIMOVI = widget.appliedFilter.FILTER_ROW.CDFILIAL;
            widget.currentRow.CONTAINER = widget.container.name;

            return this.getDtprocessa(operador[0].CDFILIALSELECIONADA).then((DTPROCESSA) => {
                widget.currentRow.DTLANCESTQ = (DTPROCESSA) ? DTPROCESSA : moment().format('DD/MM/YYYY');
            });
        });
    };

    this.importarProdutosTxt = function(widget) {

        if (!widget.isValid()) return;

        var mainWidget = widget.container.getWidget();
        var ignoredKeys = ["__rightActions", "__createdLocal", "__index", "$error"];
        const modelXlsWidget = templateManager.container.getWidget('modelWidget');
        const widgetAjuste = templateManager.container.getWidget('est41000_ajusteInventario');
        
        const popUpErrosImportacao = templateManager.container.getWidget('PopUpErroImportArquivo');
         
         
        const catchManager = (error) => {
        
            
            if (typeof error.dataSet !== 'undefined' && !Util.isEmptyOrBlank(error.dataset.itensWithErrors))
                this.showImportationDivergencies(error.dataset.itensWithErrors);

            if (error.data) {
                if (error.data.error.includes('XLS_READER_FILE_FORMAT_ERROR')) {
                    if (widget.container.name == 'est41000_ajuste_inventario') {
                        ScreenService.goBack().then(() => {
                            ScreenService.closeSwipe();
                        });
                    }
                    MessageService.showMessageByCode('INVALID_XLS_FILE');
                }
                else
                    ScreenService.showMessage(error.data.error);
            }
            else
                ScreenService.showMessage(error);
            ScreenService.hideLoader();
        };

        ScreenService.showLoader();
        if (widget.container.name == 'est41000_ajuste_inventario')
            mainWidget.newRow();

        this.setAjusteImportTxt(mainWidget).then(() => {
            widget.currentRow.CDFILIAL = mainWidget.currentRow.CDFILIAL;
            widget.currentRow.DTLANCESTQ = mainWidget.currentRow.DTLANCESTQ;
            widget.currentRow.CONTAINER = widget.container.name;
            widget.currentRow.CDFILIMOVI = mainWidget.appliedFilter.FILTER_ROW.CDFILIAL;
            //check if the file is xls or xlsx
            if (!widget.currentRow.UPLOADFILE[0].type.includes('text/plain')) {
                let file = widget.currentRow.UPLOADFILE;
                let pos = file[0].b64File.indexOf(',') + 1;

                widget.currentRow.CAMPOS = modelXlsWidget.fields.filter(field => field.isVisible == true).map(field => field.name);
                widget.currentRow.FILE = {
                    'name': file[0].name,
                    'content': file[0].b64File.substr(pos)
                };
            }
            Ajuste_Service.importarProdutosTxt(Util.clone(widget.currentRow, ignoredKeys)).then(success => {
                var itensAjuste = success.dataset.itensAjuste;
                var itensImplantacao = success.dataset.itensImplantacao;
                
                const itensErrors = success.dataset.itensWithErrors;
                const itensWithErrors = itensErrors ? itensErrors : null;
                
                if(itensWithErrors != null){
                    popUpErrosImportacao.dataSource.data = itensErrors;
                    ScreenService.openPopup(popUpErrosImportacao);
                    ScreenService.hideLoader();
                }
                var produtosDataSource = templateManager.container.getWidget('Produtos').dataSource;
                ScreenService.closeSwipe().then(() => {
                    mainWidget.activate().then(() => {
                        if (itensImplantacao.length > 0) {
                            if (widget.container.name == 'est41000_ajuste_inventario') {
                                ScreenService.hideLoader();
                                ScreenService.confirmMessage("Existem produtos sem custo em estoque. Deseja gerar implantação para estes produtos?", "CONFIRMATION",
                                    () => {
                                        itensImplantacao.forEach((row) => {
                                            row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(itensImplantacao);
                                            row.__is_new = true;
                                            row.changed = true;
                                            row.IDTIPOMOVI = '0';
                                        });

                                        var rowAjuste = Util.clone(mainWidget.currentRow, ignoredKeys.concat(["ITENS"]));
                                        rowAjuste.__is_new = true;
                                        rowAjuste.IDTPLANCTO = '0';
                                        rowAjuste.NRLANCESTQ = "";
                                        rowAjuste.DSLANCESTQ = "Lançamento realizado por importação de inventário";
                                        rowAjuste.DTLANCESTQ = itensImplantacao[0].DTLANCESTQ;

                                        Ajuste_Service.gerarImplantacao(rowAjuste, itensImplantacao).then(() => {
                                            MessageService.successNotificationByCode('IMPLANTATION_SUCCESS');
                                            mainWidget.activate();
                                            mainWidget.reload().then(_ => {
                                                ScreenService.closeSwipe();
                                                if (widget.container.name == 'est42000_implantacao_estoque') {
                                                    ScreenService.closeSwipe();
                                                    widget.container.getWidget('est42000_implantacao_estoque').reload();
                                                }
                                            });
                                        }).catch(error => {
                                            if (error.data) {
                                                ScreenService.showMessage(error.data.error);
                                            }
                                            else {
                                                ScreenService.showMessage(error);
                                            }
                                        });
                                    }, () => {
                                        mainWidget.activate();
                                        mainWidget.reload().then(_ => {
                                            ScreenService.closeSwipe();
                                        });
                                    });
                            }
                            else { //fim widget.container.name == 'est41000_ajuste_inventario'
                                itensImplantacao.forEach((row) => {
                                    row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(itensImplantacao);
                                    row.__is_new = true;
                                    row.changed = true;
                                    row.IDTIPOMOVI = '0';

                                });

                                var rowAjuste = Util.clone(mainWidget.currentRow, ignoredKeys.concat(["ITENS"]));
                                rowAjuste.__is_new = true;
                                rowAjuste.IDTPLANCTO = '0';
                                rowAjuste.NRLANCESTQ = "";
                                rowAjuste.DSLANCESTQ = "Lançamento realizado por importação de inventário";
                                rowAjuste.DTLANCESTQ = itensImplantacao[0].DTLANCESTQ;

                                Ajuste_Service.gerarImplantacao(rowAjuste, itensImplantacao).then(() => {
                                    MessageService.successNotificationByCode('IMPLANTATION_SUCCESS');
                                    ScreenService.hideLoader();
                                    mainWidget.reload();
                                    // ScreenService.closeSwipe().then(_ => {
                                    //     mainWidget.reload();
                                    //     if (widget.container.name == 'est42000_implantacao_estoque') {
                                    //         ScreenService.closeSwipe();
                                    //         widget.container.getWidget('est42000_implantacao_estoque').reload();
                                    //     }
                                    // });
                                }).catch(error => {
                                    if (error.data) {
                                        ScreenService.showMessage(error.data.error);
                                    }
                                    else {
                                        ScreenService.showMessage(error);
                                    }
                                    
                                });
                            }
                        }
                        else if (itensAjuste.length == 0) {
                            ScreenService.showMessage("Não foram encontrados nenhum produto a partir do arquivo");
                        }

                        if (itensAjuste.length > 0) {
                            widgetAjuste.currentRow.DTLANCESTQ = itensAjuste[0].DTLANCESTQ;
                            produtosDataSource.data = itensAjuste;
                            produtosDataSource.data.forEach((row) => {
                                row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(produtosDataSource.data);
                                row.IDAJUSTEIMPORT = 'S';
                                row.__is_new = true;
                                row.d = true;
                                row.IDTIPOMOVI = row.IDTIPOMOVI ? row.IDTIPOMOVI : '1';
                                ScreenService.hideLoader();
                            });
                            this.saveImport(widget).then(() => {
                                ScreenService.closeSwipe().then(_ => {
                                    widgetAjuste.reload();
                                    widgetAjuste.list();
                                    MessageService.successNotificationByCode('ADJUST_SUCCESS');
                                });
                            });

                        }
                        else if (itensImplantacao.length == 0) {
                            ScreenService.showMessage("Não foram encontrados nenhum produto a partir do arquivo");
                        }

                    });
                });
            }).catch((error) => {
                ScreenService.closeSwipe().then(() => {
                    ScreenService.closeSwipe();
                    widget.reload();
                }).then(() => {
                    catchManager(error);
                });
            });
        });
    };

    this.showImportationDivergencies = function(errorData) {
        let adjustWidget = templateManager.container.getWidget('est41000_ajusteInventario');
        let tabWidget = templateManager.container.getWidget('tabImportWidget');
        let widgetErrors = templateManager.container.getWidget('errorsWidget');
        errorData.forEach(row => {
           row.DESCERROR = ScreenService.i18n('row.DESCERROR');
        });
        adjustWidget.list(true);
        adjustWidget.dataSource.data.pop();
        adjustWidget.currentRow = {};

        ScreenService.closeSwipe().then(_ => {
            widgetErrors.dataSource.data = errorData;
            tabWidget.isVisible = true;
            widgetErrors.reload().then(_ => {
                widgetErrors.activate();
            });
        });
    };

    this.importProducts = function(widget) {
        if (widget.isValid()) {
            try {
                if (widget.getField("AJUSTEPOR").value() === "U") {
                    ScreenService.showLoader();
                    Ajuste_Service.retornaParamUnidade(widget.getParent().getParent().currentRow.CDFILIMOVI).then(function(paramfilial) {
                        Ajuste_Service.importProductsFilial(widget.currentRow.CDORDENA, widget.getParent().getParent().currentRow.CDFILIMOVI, widget.getParent().getParent().currentRow.DTLANCESTQ, paramfilial.dataset.paramfilial[0].DTPROCESSA).then(function(success) {
                            var products = success.dataset.products;
                            var parentDataSource = widget.getParent().dataSource;

                            if (products.length > 0) {
                                parentDataSource.data = products;

                                parentDataSource.data.forEach(function(row) {
                                    row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(parentDataSource.data);
                                    row.IDAJUSTEIMPORT = 'S';
                                    row.__is_new = true;
                                    row.changed = true;
                                    row.CDFILIAL = widget.getParent().getParent().currentRow.CDFILIAL;
                                    //row.IDTIPOMOVI = row.IDTIPOMOVI ? row.IDTIPOMOVI : '1';
                                    row.IDTIPOMOVI = (widget.getParent().getParent().currentRow.IDTPLANCTO == 0) ? '0' : '1';
                                });

                                //O CÓDIGO DESSA TELA É INACEITÁVEL E É IMPERATIVO QUE ESTE SEJA COMPLETAMENTE REESCRITO.
                                this.saveImport(widget);

                                ScreenService.closePopup();
                            }
                            else {
                                ScreenService.hideLoader();
                                ScreenService.confirmMessage("A importação de itens não encontrou produtos válidos cadastrados para a origem selecionada. Inserir manualmente?", "CONFIRMATION", function confimed() {
                                    ScreenService.closePopup();

                                    this.newItem(widget.getParent());
                                }.bind(this));
                            }

                        }.bind(this), (error) => {
                            ScreenService.showMessage(error.error);
                            ScreenService.hideLoader();
                        });
                    }.bind(this));
                }
                else {
                    if (widget.getField("AJUSTEPOR").value() === "E") {
                        ScreenService.showLoader();
                        Ajuste_Service.retornaParamUnidade(widget.getParent().getParent().currentRow.CDFILIMOVI).then(function(paramfilial) {
                          Ajuste_Service.importProductsPosicao(widget.currentRow.CDORDENA, widget.getParent().getParent().currentRow.CDFILIMOVI, widget.getParent().getParent().currentRow.DTLANCESTQ, paramfilial.dataset.paramfilial[0].DTPROCESSA).then(function(success) {
                            var products = success.dataset.products;
                            var parentDataSource = widget.getParent().dataSource;
                            if (products.length > 0) {
                                parentDataSource.data = products;

                                parentDataSource.data.forEach(function(row) {
                                    row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(parentDataSource.data);
                                    row.IDAJUSTEIMPORT = 'S';
                                    row.__is_new = true;
                                    row.changed = true;
                                    row.CDFILIAL = widget.getParent().getParent().currentRow.CDFILIAL;
                                    //row.IDTIPOMOVI = row.IDTIPOMOVI ? row.IDTIPOMOVI : '1';
                                    row.IDTIPOMOVI = (widget.getParent().getParent().currentRow.IDTPLANCTO == 0) ? '0' : '1';
                                });

                                this.saveImport(widget);

                                ScreenService.closePopup();
                            }
                          }.bind(this));
                        }.bind(this));
                
                    }
                    else {
                        ScreenService.showLoader();
                        Ajuste_Service.importProducts(widget.currentRow.CDGRUPPROD, widget.currentRow.CDORDENA, widget.getParent().getParent().currentRow.CDFILIMOVI, widget.getParent().getParent().currentRow.DTLANCESTQ, widget.currentRow.IDGRUPPROD).then(function(success) {
                            var products = success.dataset.products;
                            var parentDataSource = widget.getParent().dataSource;

                            if (products.length > 0) {
                                parentDataSource.data = products;

                                parentDataSource.data.forEach(function(row) {
                                    row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(parentDataSource.data);
                                    row.IDAJUSTEIMPORT = 'S';
                                    row.__is_new = true;
                                    row.changed = true;
                                    row.CDFILIAL = widget.getParent().getParent().currentRow.CDFILIAL;
                                    //row.IDTIPOMOVI = row.IDTIPOMOVI ? row.IDTIPOMOVI : '1';
                                    row.IDTIPOMOVI = (widget.getParent().getParent().currentRow.IDTPLANCTO == 0) ? '0' : '1';
                                });

                                //O CÓDIGO DESSA TELA É INACEITÁVEL E É IMPERATIVO QUE ESTE SEJA COMPLETAMENTE REESCRITO.
                                this.saveImport(widget);

                                ScreenService.closePopup();
                            }
                            else {
                                // ScreenService.confirmMessage("A importação de itens a partir do agrupamento \"" + widget.currentRow.NMGRUPPROD + "\" não encontrou produtos válidos cadastrados para a origem selecionada. Inserir manualmente?", "CONFIRMATION", function confimed() {
                                //     ScreenService.closePopup();

                                //     this.newItem(widget.getParent());
                                // }.bind(this));
                                ScreenService.hideLoader();

                                MessageService.confirmMessageByCode("ERRO_IMPORT_AGRUPAMENTO", { "PARAMETRO": widget.currentRow.NMGRUPPROD }).then(function() {
                                    ScreenService.closePopup();

                                    this.newItem(widget.getParent());

                                }.bind(this));
                            }

                        }.bind(this), (error) => {
                            ScreenService.showMessage(error.error);
                            ScreenService.hideLoader();
                        });
                    }
                }

            }
            catch (error) {
                ScreenService.showMessage(error);
                ScreenService.hideLoader();
            }
        }
    };

    this.saveImport = (widget) => new Promise(resolve => {
        var widgetItem = widget.container.getWidget('Produtos');

        //SALVA A PRIMEIRA ROW + AJUSTE COM UM REQUEST
        //CONTROLE DE ALMOXARIFADO--colocar aqui
        var rowItem = {};
        Util.extend(rowItem, widgetItem.dataSource.data[0]);
        rowItem.CDFILIMOVI = widgetItem.getParent().currentRow.CDFILIMOVI;
        rowItem.IDAJUSTEIMPORT = 'S';
        var widgetLancamento = widgetItem.getParent();
        var rowAjuste = widgetLancamento.currentRow;
        delete rowItem.__rightActions;
        var closureObj = {};
        closureObj.rowItem = rowItem;
        closureObj.widgetItem = widgetItem;
        if (widget.currentRow.CDGRUPPROD) //codigo do grupo da importação
            rowAjuste.CDGRUPPRODLCEST = widget.currentRow.CDGRUPPROD;

        ScreenService.showLoader();

        Ajuste_Service.validaAjuste(rowItem, rowAjuste.DTLANCESTQ).then(function(success) {
            ValidacoesEstoque_Service.validaDataLancamento(rowAjuste.CDFILIMOVI, rowAjuste.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(function(success) {
                Ajuste_Service.save(rowItem, rowAjuste).then(function(lancamento) {
                    ScreenService.hideLoader();
                    widgetItem.getAction('import').isVisible = false;

                    if (lancamento.dataset['/lanctoestoq/save'] !== undefined) {
                        var rowLancamento = lancamento.dataset['/lanctoestoq/save'];
                        var itens = rowLancamento.ITENS;
                        delete rowLancamento.itens;
                        widgetItem.dataSource.data[0] = itens[0];
                        widgetLancamento.currentRow.NRLANCESTQ = rowLancamento.NRLANCESTQ;
                        widgetLancamento.currentRow.__is_new = false;
                    }
                    else {
                        widgetLancamento.currentRow.NRLANCESTQ = rowAjuste.NRLANCESTQ;
                    }

                    widgetLancamento.view();
                    widgetItem.dataSource.data[0].IDEVOLESTOQ = 'N';
                    widgetItem.dataSource.data[0].__is_new = false;
                    widgetItem.dataSource.data[0].changed = false;
                    widgetItem.dataSource.data[0].NRLANCESTQ = widgetLancamento.currentRow.NRLANCESTQ;
                    //widgetItem.updateGridActions();

                    //SALVA AS DEMAIS ROWS
                    var dataSemCusto = widgetItem.dataSource.data.filter(produto => {
                        if (produto.hasOwnProperty('CUSTO'))
                            return produto.CUSTO.valrMed == 0;
                        else
                            return false;
                    });
                    var dataComCusto = widgetItem.dataSource.data.filter(produto => {
                        if (produto.hasOwnProperty('CUSTO'))
                            return produto.CUSTO.valrMed != 0;
                        else
                            return true;
                    });

                    if (dataSemCusto.length > 0) {
                        ScreenService.confirmMessage("Existem produtos sem custo em estoque. Deseja gerar implantação para estes produtos?", "CONFIRMATION", () => {
                            dataSemCusto.forEach((row) => {
                                row.NRSEQUITEM = Ajuste_Service.geraNrsequitem(dataSemCusto);
                                row.__is_new = true;
                                row.changed = true;
                                row.IDTIPOMOVI = '0';
                            });

                            var ignoredKeys = ["__rightActions", "__createdLocal", "__index", "$error"];
                            var rowAjuste = Util.clone(widgetLancamento.currentRow, ignoredKeys.concat(["ITENS"]));
                            rowAjuste.__is_new = true;
                            rowAjuste.IDTPLANCTO = '0';
                            rowAjuste.NRLANCESTQ = "";
                            rowAjuste.DSLANCESTQ = "Lançamento realizado por importação de inventário";
                            rowAjuste.DTLANCESTQ = dataSemCusto[0].DTLANCESTQ;

                            Ajuste_Service.gerarImplantacao(rowAjuste, dataSemCusto).then(() => {
                                MessageService.successNotificationByCode('IMPLANTATION_SUCCESS');
                                ScreenService.hideLoader();
                                resolve();
                            }).catch(error => {
                                if (error.data) {
                                    ScreenService.showMessage(error.data.error);
                                    ScreenService.hideLoader();
                                }
                                else {
                                    ScreenService.showMessage(error);
                                    ScreenService.hideLoader();
                                }
                            });
                        });
                    }

                    widgetItem.dataSource.data = dataComCusto;
                    ScreenService.hideLoader(); // verificar se este hideloader pode realmente ficar aqui. Pois em caso de lentidao tem chance de perder os registros
                    Ajuste_Service.saveImportRows(dataComCusto, Util.clone(rowAjuste, ["__rightActions", "__leftActions"])).then(function(success) {
                        widgetItem.dataSource.data.forEach(function(row) {
                            row.IDEVOLESTOQ = 'N';
                            row.IDAJUSTEIMPORT = 'S';
                            row.__is_new = false;
                            row.changed = false;
                            row.NRLANCESTQ = widgetLancamento.currentRow.NRLANCESTQ;
                        });
                        //widgetItem.updateGridActions();
                        widgetItem.list();
                        //widgetItem.reload(); nao perder o calculo do vrunibrut
                        resolve();
                        ScreenService.hideLoader();
                    }, function(error) {
                        ScreenService.showMessage(error.data.error);
                        ScreenService.hideLoader();
                    });
                }, function(error) {
                    ScreenService.showMessage(error.data.error);
                    ScreenService.hideLoader();
                });
            }, function(error) {
                ScreenService.showMessage(error.data.error);
                ScreenService.hideLoader();
            });
        }, function(error) {
            var closure = this[1];
            closure.rowItem.SEMCUSTO = true;
            closure.widgetItem.dataSource.data[0].SEMCUSTO = true;
            ScreenService.showMessage(error.data.error);
            ScreenService.hideLoader();
        }.bind([this, closureObj]));
    });

    this.onSaveAjuste = function(widget) {
        var widgetItens = widget.widgets[0];
        var row = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);

        if (widget.isValid()) {
            if (row.__is_new) {
                ScreenService.showLoader();
                ValidacoesEstoque_Service.validaDataLancamento(row.CDFILIMOVI, row.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(function() {
                    if (widgetItens.getAction('import'))
                        widgetItens.getAction('import').isVisible = true;

                    widget.container.getWidget('Produtos').enabled = true;

                    widgetItens.activate();
                    ScreenService.hideLoader();
                }, function(error) {
                    ScreenService.showMessage(error.data.error);
                    ScreenService.hideLoader();
                });
            }
            else {
                Ajuste_Service.editAjuste(row).then(function() {
                    widget.view();
                    widget.container.getWidget('Produtos').enabled = true;
                });
            }
        }
    };

    this.openNewRowOnProdutoGrid = function(widget) {
        if (widget.getParent().currentRow.__is_new && widget.mode === 'list') {
            widget.dataSource.data = [];
            widget.newRow();
            ScreenService.showMessage('É necessário ao menos um produto para efetuar o lançamento!');
        }
    };

    var rowEditedInline = function(row) {
        let boolEdited = false;

        $.each(row, function(index, value) {
            if (row.hasOwnProperty('changed_' + index)) {
                boolEdited = true;
            }
        });

        return boolEdited;
    };

    this.newOnSaveItemBackend = function(widgetItem) {
        var self = this;
        if (widgetItem.isValid()) {
            var rows = widgetItem.dataSource.data;

            rows = rows.filter(function(row) {
                return row.changed === true && (!row.__is_new || rowEditedInline(row));
            });

            if (widgetItem.currentRow.__is_new) {
                if (Ajuste_Service.validaItem(widgetItem.currentRow, widgetItem.dataSource.data)) {
                    var boolDontPush = rows.some(row => widgetItem.currentRow === row);
                    if (!boolDontPush)
                        rows.push(widgetItem.currentRow);
                }
                else
                    ScreenService.showMessage('Produto já foi incluido neste lançamento!');
            }
            ScreenService.showLoader();
            Ajuste_Service.retornaParamUnidade(widgetItem.getParent().currentRow.CDFILIMOVI).then(paramfilial => {
                var closure = {};
                var param = paramfilial.dataset.paramfilial[0];
                var rowAjuste = widgetItem.getParent().currentRow;
                var mensagemCusto = param.IDVISPOSAJINVE == 'S' && ((rowAjuste.IDTIPOMOVI == '1' ? true : false) || (rowAjuste.IDTPLANCTO == '1' ? true : false));
                var dtLanc = rowAjuste.DTLANCESTQ;
                var popupCustoProduto = templateManager.container.getWidget('PopUpCustoProduto');
                var arrayCustos = [];
                var arrayItemsToSave = [];
                var validacoesProcessadas = 0;
                var rowsLength = rows.length;
                let qntValida = true;
                var rowGetMax = {
                    CDFILIAL: widgetItem.getParent().currentRow.CDFILIAL,
                    NRLANCESTQ: widgetItem.getParent().currentRow.NRLANCESTQ
                };

                closure.validacoesProcessadas = validacoesProcessadas;

                rows.forEach(row => {
                    row.CDFILIMOVI = row.CDFILIMOVI ? row.CDFILIMOVI : widgetItem.getParent().currentRow.CDFILIMOVI;
                    var rowItem = {};
                    var arraySemcusto = [];

                    Util.extend(rowItem, row);
                    delete rowItem.__rightActions;

                    rowItem.VRUNITBRUT = rowItem.VRUNITBRUT_inline || rowItem.VRUNITBRUT;
                    rowItem.VRUNILANCTO = rowItem.VRUNILANCTO_inline || rowItem.VRUNILANCTO;
                    rowItem.QTTOTLANCTO = rowItem.QTTOTLANCTO_inline || rowItem.QTTOTLANCTO;

                    arrayItemsToSave.push(rowItem);
                });

                General.callRestEngine("est_ajuste#/validaAjusteTotal", "DataSet", arrayItemsToSave).then((response) => {
                    var dataSetComCusto = response.dataset.custos;
                    var notEditedDataset = widgetItem.dataSource.data.filter(row => {
                        return !dataSetComCusto.some(custo => custo.NRSEQUITEM == row.NRSEQUITEM);
                    });

                    if (dataSetComCusto.some(produto => produto.SEMCUSTO != "false"))
                        ScreenService.showMessage('Produto com custo de estoque zerado.');

                    if (dataSetComCusto.some(produto => produto.IMPLANTADOMESMODIA != "false"))
                        ScreenService.showMessage('Produto com implantação no mesmo dia.');

                    let arr = dataSetComCusto;

                    for (let i = 0, len = arr.length; i < len; i++) {
                        let custo = {},
                            row = arr[i];
                        custo.valrAnte = row.VALRANTE;
                        custo.qtdeAnte = row.QTDEANTE;
                        custo.valrMedi = row.VALRMEDI;
                        custo.vlAnterior = row.VLANTERIOR;
                        custo.item = Util.clone(row);
                        Util.extend(row, custo);
                    }

                    // se mensagemCusto for false a validação não será feita no Ajuste_Service.openP opupCusto
                    if (!mensagemCusto && dataSetComCusto) {
                        dataSetComCusto.forEach(row => {
                            var boolValido = qntValida === false ? qntValida : this.validaCusto(row, row);
                            if (!boolValido) {
                                ScreenService.showMessage('Quantidade informada fora do Permitido');
                                qntValida = false;
                            }
                        });
                    }

                    if (mensagemCusto) {
                        ScreenService.hideLoader();
                        Ajuste_Service.openPopupCusto(dataSetComCusto, popupCustoProduto).then(() => {
                            ScreenService.showLoader();
                            let dataCustoToSave = dataSetComCusto.filter(row => {
                                return ((row.SEMCUSTO ? row.SEMCUSTO == "false" : true) &&
                                    (row.IRREGULAR ? row.IRREGULAR == "false" : true) &&
                                    (row.qntValida ? row.qntValida == true : true) &&
                                    (row.IMPLANTADOMESMODIA ? row.IMPLANTADOMESMODIA == "false" : true));
                            });

                            let dataNeedNrseq = dataCustoToSave.filter(row => {
                                return !row.NRSEQUITEM;
                            });

                            General.callRestEngine("est_ajuste#/getMaxNrSeqItemAjuste", "Row", rowGetMax).then((response) => {
                                let nextSeq = response.dataset.getMaxNrSeqItemAjuste[0];

                                let dataSetWithSeq = dataCustoToSave.filter(row => {
                                    return !dataNeedNrseq.some(data => data.NRSEQUITEM == row.NRSEQUITEM);
                                });
                                if (dataNeedNrseq.length > 0) {
                                    let arr = dataNeedNrseq;
                                    for (let i = 0, len = arr.length; i < len; i++) {
                                        let cRow = arr[i];
                                        cRow.NRSEQUITEM = nextSeq + i;
                                    }

                                    dataSetWithSeq = dataSetWithSeq.concat(dataNeedNrseq);
                                }

                                Ajuste_Service.saveImportRows(dataSetWithSeq, rowAjuste).then(function(success) {
                                        widgetItem.dataSource.data = dataSetComCusto.concat(notEditedDataset);
                                        widgetItem.dataSource.data.forEach(function(row) {
                                            row.IDEVOLESTOQ = 'N';
                                            row.__is_new = false;
                                            for (var e in row) {
                                                if (e.indexOf('changed') !== -1 || e.indexOf('_inline') !== -1)
                                                    delete row[e];
                                            }
                                            row.changed = false;
                                        });

                                        //widgetItem.updateGridActions();
                                        widgetItem.list();
                                        ScreenService.hideLoader();
                                    },
                                    function(error) {
                                        ScreenService.showMessage(error.data.error);
                                        ScreenService.hideLoader();
                                    });

                            });

                        }).catch((error) => {
                            if (typeof error !== 'undefined') {
                                MessageService.showMessageByCode(error.err);
                            }
                        });
                    }
                    else {
                        if (qntValida) {
                            let dataCustoToSave = dataSetComCusto.filter(row => {
                                return ((row.SEMCUSTO ? row.SEMCUSTO == "false" : true) &&
                                    (row.IRREGULAR ? row.IRREGULAR == "false" : true) &&
                                    (row.qntValida ? row.qntValida == true : true));
                            });

                            let dataNeedNrseq = dataCustoToSave.filter(row => {
                                return !row.NRSEQUITEM;
                            });

                            General.callRestEngine("est_ajuste#/getMaxNrSeqItemAjuste", "Row", rowGetMax).then((response) => {
                                let nextSeq = response.dataset.getMaxNrSeqItemAjuste[0];

                                let dataSetWithSeq = dataCustoToSave.filter(row => {
                                    return !dataNeedNrseq.some(data => data.NRSEQUITEM == row.NRSEQUITEM);
                                });
                                if (dataNeedNrseq.length > 0) {
                                    let arr = dataNeedNrseq;
                                    for (let i = 0, len = arr.length; i < len; i++) {
                                        let cRow = arr[i];
                                        cRow.NRSEQUITEM = nextSeq + i;
                                    }

                                    dataSetWithSeq = dataSetWithSeq.concat(dataNeedNrseq);
                                }

                                Ajuste_Service.saveImportRows(dataSetWithSeq, rowAjuste).then(function(success) {
                                        widgetItem.dataSource.data = dataSetComCusto.concat(notEditedDataset);
                                        widgetItem.dataSource.data.forEach(function(row) {
                                            row.IDEVOLESTOQ = 'N';
                                            row.__is_new = false;
                                            for (var e in row) {
                                                if (e.indexOf('changed') !== -1 || e.indexOf('_inline') !== -1)
                                                    delete row[e];
                                            }
                                            row.changed = false;
                                        });

                                        //widgetItem.updateGridActions();
                                        widgetItem.list();
                                        ScreenService.hideLoader();
                                    },
                                    function(error) {
                                        ScreenService.showMessage(error.data.error);
                                        ScreenService.hideLoader();
                                    });

                            });
                        }
                    }
                    var newDataset = notEditedDataset.concat(dataSetComCusto);
                    widgetItem.dataSource.data = newDataset;
                });
            });

        }
    };

    this.onSaveItem = function(widgetItem) {
        var self = this;
        if (widgetItem.isValid()) {
            ScreenService.showLoader();
            var rows = widgetItem.dataSource.data;

            rows = rows.filter(function(row) {
                return row.changed === true && (!row.__is_new || rowEditedInline(row));
            });

            if (widgetItem.currentRow.__is_new) {
                if (Ajuste_Service.validaItem(widgetItem.currentRow, widgetItem.dataSource.data)) {
                    var boolDontPush = rows.some(row => widgetItem.currentRow === row);
                    if (!boolDontPush)
                        rows.push(widgetItem.currentRow);
                }
                else {
                    ScreenService.showMessage('Produto já incluído neste lançamento!');
                    ScreenService.hideLoader();
                }
            }

            //NOVO DAQUI PARA BAIXO
            //VALIDACOES
            //Foreach do popupCusto
            Ajuste_Service.retornaParamUnidade(widgetItem.getParent().currentRow.CDFILIMOVI).then(paramfilial => {
                var closure = {};
                var param = paramfilial.dataset.paramfilial[0];
                var rowAjuste = widgetItem.getParent().currentRow;
                var mensagemCusto = param.IDVISPOSAJINVE == 'S' && ((rowAjuste.IDTIPOMOVI == '1' ? true : false) || (rowAjuste.IDTPLANCTO == '1' ? true : false));
                var dtLanc = rowAjuste.DTLANCESTQ;
                var popupCustoProduto = templateManager.container.getWidget('PopUpCustoProduto');
                var arrayCustos = [];
                var arrayItemsToSave = [];
                var validacoesProcessadas = 0;
                var rowsLength = rows.length;
                let qntValida = true;

                closure.validacoesProcessadas = validacoesProcessadas;

                //if(rows.length == 0)
                //  ScreenService.hideLoader();
                rows.forEach(row => {
                    row.CDFILIMOVI = row.CDFILIMOVI ? row.CDFILIMOVI : widgetItem.getParent().currentRow.CDFILIMOVI;
                    var rowItem = {};
                    var arraySemcusto = [];
                    var rowGetMax = {
                        CDFILIAL: widgetItem.getParent().currentRow.CDFILIAL,
                        NRLANCESTQ: widgetItem.getParent().currentRow.NRLANCESTQ
                    };

                    Util.extend(rowItem, row);
                    delete rowItem.__rightActions;

                    rowItem.VRUNITBRUT = rowItem.VRUNITBRUT_inline || rowItem.VRUNITBRUT;
                    rowItem.VRUNILANCTO = rowItem.VRUNILANCTO_inline || rowItem.VRUNILANCTO;
                    rowItem.QTTOTLANCTO = rowItem.QTTOTLANCTO_inline || rowItem.QTTOTLANCTO;
                    closure.rowItem = rowItem;
                    var closureObj = {};
                    closureObj.closure = closure;
                    closureObj.row = row;
                    closureObj.rowItem = rowItem;

                    Ajuste_Service.validaAjuste(rowItem, dtLanc).then(function(success) {
                        if (success) {
                            var custo = success.dataset.custo;
                            custo.CDARVPROD = rowItem.CDARVPROD;
                            custo.NMPRODUTO = rowItem.NMPRODUTO;
                            custo.item = rowItem;
                            arrayCustos.push(custo);

                            // se mensagemCusto for false a validação não será feita no Ajuste_Service.openP opupCusto
                            if (!mensagemCusto && success) {
                                qntValida = qntValida === false ? qntValida : this.validaCusto(custo, row);
                            }
                        }

                        ValidacoesEstoque_Service.validaDataLancamento(rowAjuste.CDFILIMOVI, rowAjuste.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(success => {
                                if (!row.NRSEQUITEM) {
                                    General.callRestEngine("est_ajuste#/getMaxNrSeqItemAjuste", "Row", rowGetMax).then((response) => {
                                        rowItem.NRSEQUITEM = response.dataset.getMaxNrSeqItemAjuste[0];
                                        arrayItemsToSave.push(rowItem);
                                        closure.validacoesProcessadas++;
                                        if (closure.validacoesProcessadas == rowsLength) {
                                            if (qntValida) {
                                                if (mensagemCusto) {
                                                    ScreenService.hideLoader();
                                                    Ajuste_Service.openPopupCusto(arrayCustos, popupCustoProduto).then(() => {
                                                        ScreenService.showLoader();
                                                        popupCustoProduto.dataSourceFilter = [];
                                                        arrayItemsToSave.forEach(item => {
                                                            Ajuste_Service.save(item, rowAjuste).then((lancamento) => {
                                                                if (widgetItem.getAction('import'))
                                                                    widgetItem.getAction('import').isVisible = false;

                                                                var widgetLancamento = widgetItem.getParent();
                                                                if (lancamento.dataset['/lanctoestoq/save'] !== undefined) {
                                                                    var rowLancamento = lancamento.dataset['/lanctoestoq/save'];
                                                                    var itens = rowLancamento.ITENS;
                                                                    delete rowLancamento.itens;

                                                                    Object.keys(itens[0]).forEach(function(key) {
                                                                        widgetItem.currentRow[key] = itens[0][key];
                                                                    });

                                                                    widgetLancamento.currentRow.NRLANCESTQ = rowLancamento.NRLANCESTQ;
                                                                    widgetLancamento.currentRow.__is_new = false;
                                                                }
                                                                else {
                                                                    widgetLancamento.currentRow.NRLANCESTQ = rowAjuste.NRLANCESTQ;
                                                                }

                                                                widgetLancamento.view();

                                                                if (rowItem.__is_new && !rowEditedInline(rowItem)) {
                                                                    ScreenService.closeSwipe().then(function() {
                                                                        widgetItem.list();
                                                                    });
                                                                }
                                                                else {
                                                                    widgetItem.commitInlineEdit();
                                                                    widgetItem.list();
                                                                }

                                                                rowItem.IRREGULAR = false;
                                                                row.IDEVOLESTOQ = 'N';

                                                                widgetItem.currentRow.__is_new = false;
                                                                widgetItem.currentRow.changed = false;
                                                                widgetItem.currentRow.NRLANCESTQ = widgetLancamento.currentRow.NRLANCESTQ;
                                                                //widgetItem.updateGridActions();
                                                                widgetItem.reload();

                                                                ScreenService.hideLoader();
                                                            }, function(error) {
                                                                ScreenService.showMessage(error.data.error);
                                                                ScreenService.hideLoader();
                                                            });
                                                        });
                                                    }).catch((error) => {
                                                        if (typeof error !== 'undefined') {
                                                            MessageService.showMessageByCode(error.err);
                                                        }
                                                    });
                                                }
                                                else {
                                                    arrayItemsToSave.forEach(item => {
                                                        Ajuste_Service.save(item, rowAjuste).then((lancamento) => {
                                                            if (widgetItem.getAction('import'))
                                                                widgetItem.getAction('import').isVisible = false;

                                                            var widgetLancamento = widgetItem.getParent();
                                                            if (lancamento.dataset['/lanctoestoq/save'] !== undefined) {
                                                                var rowLancamento = lancamento.dataset['/lanctoestoq/save'];
                                                                var itens = rowLancamento.ITENS;
                                                                delete rowLancamento.itens;

                                                                Object.keys(itens[0]).forEach(function(key) {
                                                                    widgetItem.currentRow[key] = itens[0][key];
                                                                });

                                                                widgetLancamento.currentRow.NRLANCESTQ = rowLancamento.NRLANCESTQ;
                                                                widgetLancamento.currentRow.__is_new = false;
                                                            }
                                                            else {
                                                                widgetLancamento.currentRow.NRLANCESTQ = rowAjuste.NRLANCESTQ;
                                                            }

                                                            widgetLancamento.view();

                                                            if (rowItem.__is_new && !rowEditedInline(rowItem)) {
                                                                ScreenService.closeSwipe().then(function() {
                                                                    widgetItem.list();
                                                                });
                                                            }
                                                            else {
                                                                widgetItem.commitInlineEdit();
                                                                widgetItem.list();
                                                            }

                                                            rowItem.IRREGULAR = false;
                                                            row.IDEVOLESTOQ = 'N';

                                                            widgetItem.currentRow.__is_new = false;
                                                            widgetItem.currentRow.changed = false;
                                                            widgetItem.currentRow.NRLANCESTQ = widgetLancamento.currentRow.NRLANCESTQ;
                                                            //widgetItem.updateGridActions();
                                                            widgetItem.reload();

                                                            ScreenService.hideLoader();
                                                        }, function(error) {
                                                            ScreenService.showMessage(error.data.error);
                                                            ScreenService.hideLoader();
                                                        });
                                                    });
                                                }
                                            }
                                            else {
                                                ScreenService.showMessage('Quantidade informada fora do permitido.');
                                                ScreenService.hideLoader();
                                            }
                                        }
                                    });
                                }
                                else {
                                    arrayItemsToSave.push(rowItem);
                                    closure.validacoesProcessadas++;
                                    if (closure.validacoesProcessadas == rowsLength) {
                                        if (qntValida) {
                                            if (mensagemCusto) {
                                                ScreenService.hideLoader();
                                                Ajuste_Service.openPopupCusto(arrayCustos, popupCustoProduto).then(() => {
                                                    ScreenService.showLoader();
                                                    popupCustoProduto.dataSourceFilter = [];
                                                    arrayItemsToSave.forEach(item => {
                                                        Ajuste_Service.save(item, rowAjuste).then((lancamento) => {
                                                            if (widgetItem.getAction('import'))
                                                                widgetItem.getAction('import').isVisible = false;

                                                            var widgetLancamento = widgetItem.getParent();
                                                            if (lancamento.dataset['/lanctoestoq/save'] !== undefined) {
                                                                var rowLancamento = lancamento.dataset['/lanctoestoq/save'];
                                                                var itens = rowLancamento.ITENS;
                                                                delete rowLancamento.itens;

                                                                Object.keys(itens[0]).forEach(function(key) {
                                                                    widgetItem.currentRow[key] = itens[0][key];
                                                                });

                                                                widgetLancamento.currentRow.NRLANCESTQ = rowLancamento.NRLANCESTQ;
                                                                widgetLancamento.currentRow.__is_new = false;
                                                            }
                                                            else {
                                                                widgetLancamento.currentRow.NRLANCESTQ = rowAjuste.NRLANCESTQ;
                                                            }

                                                            widgetLancamento.view();

                                                            if (rowItem.__is_new && !rowEditedInline(rowItem)) {
                                                                ScreenService.closeSwipe().then(function() {
                                                                    widgetItem.list();
                                                                });
                                                            }
                                                            else {
                                                                widgetItem.commitInlineEdit();
                                                                widgetItem.list();
                                                            }

                                                            rowItem.IRREGULAR = false;
                                                            row.IDEVOLESTOQ = 'N';

                                                            widgetItem.currentRow.__is_new = false;
                                                            widgetItem.currentRow.changed = false;
                                                            widgetItem.currentRow.NRLANCESTQ = widgetLancamento.currentRow.NRLANCESTQ;
                                                            //widgetItem.updateGridActions();
                                                            widgetItem.reload();
                                                            ScreenService.hideLoader();
                                                        }, function(error) {
                                                            ScreenService.showMessage(error.data.error);
                                                            ScreenService.hideLoader();
                                                        });
                                                    });
                                                }).catch((error) => {
                                                    if (typeof error !== 'undefined') {
                                                        MessageService.showMessageByCode(error.err);
                                                    }
                                                });
                                            }
                                            else {
                                                arrayItemsToSave.forEach(item => {
                                                    Ajuste_Service.save(item, rowAjuste).then((lancamento) => {
                                                        if (widgetItem.getAction('import'))
                                                            widgetItem.getAction('import').isVisible = false;

                                                        var widgetLancamento = widgetItem.getParent();
                                                        if (lancamento.dataset['/lanctoestoq/save'] !== undefined) {
                                                            var rowLancamento = lancamento.dataset['/lanctoestoq/save'];
                                                            var itens = rowLancamento.ITENS;
                                                            delete rowLancamento.itens;

                                                            Object.keys(itens[0]).forEach(function(key) {
                                                                widgetItem.currentRow[key] = itens[0][key];
                                                            });

                                                            widgetLancamento.currentRow.NRLANCESTQ = rowLancamento.NRLANCESTQ;
                                                            widgetLancamento.currentRow.__is_new = false;
                                                        }
                                                        else {
                                                            widgetLancamento.currentRow.NRLANCESTQ = rowAjuste.NRLANCESTQ;
                                                        }

                                                        widgetLancamento.view();

                                                        if (rowItem.__is_new && !rowEditedInline(rowItem)) {
                                                            ScreenService.closeSwipe().then(function() {
                                                                widgetItem.list();
                                                            });
                                                        }
                                                        else {
                                                            widgetItem.commitInlineEdit();
                                                            widgetItem.list();
                                                        }

                                                        rowItem.IRREGULAR = false;
                                                        row.IDEVOLESTOQ = 'N';

                                                        widgetItem.currentRow.__is_new = false;
                                                        widgetItem.currentRow.changed = false;
                                                        widgetItem.currentRow.NRLANCESTQ = widgetLancamento.currentRow.NRLANCESTQ;
                                                        //widgetItem.updateGridActions();
                                                        widgetItem.reload();
                                                        ScreenService.hideLoader();
                                                    }, function(error) {
                                                        ScreenService.showMessage(error.data.error);
                                                        ScreenService.hideLoader();
                                                    });
                                                });
                                            }
                                        }
                                        else {
                                            ScreenService.showMessage('Quantidade informada fora do permitido.');
                                            ScreenService.hideLoader();
                                        }
                                    }
                                }
                            },
                            (error) => {
                                ScreenService.showMessage(error.data.error);
                                ScreenService.hideLoader();
                            });
                    }.bind(this)).catch(function(rejected) {
                        var closur = this[1];
                        closur.row.SEMCUSTO = true;
                        closur.closure.validacoesProcessadas++;
                        ScreenService.showMessage(rejected.data.error);
                        ScreenService.hideLoader();
                    }.bind([this, closureObj]));
                });
            });
        }
    };

    this.getDtprocessa = function(cdfilial) {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": cdfilial
        }];
        return restEngine.post("est#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        }).then(function(response) {
            return response.dataset.paramfilial[0].DTPROCESSA;
        });
    };

    this.getFieldValueFilter = function(filedName, widgetName) {
        var container = templateManager.container;
        if (container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if (f) {
                    filterWidget = container.getWidget(widgetName).appliedFilter;
                }

            }

            if (filterWidget) {
                var valueField;
                if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];

                return valueField || null;
            }
            else return null;
        }
        else return null;
    };

    this.newAjuste = function(widget) {
        if (EstUtil.onValidateFilterRequirement(widget)) return;

        let tabbedWidget = widget.container.getWidget('tabImportWidget');
        tabbedWidget.enable = false;

        ScreenService.showMessage('Atenção! O lançamento será considerado pelo sistema como o ' + Ajuste_Service.getOrdemAjuste() + '.');
        widget.newRow();

        var widgetFilter = widget.appliedFilter.FILTER_ROW;

        if (widgetFilter.CDALMOXARIFE) {
            widget.currentRow.CDALMOXARIFE = widgetFilter.CDALMOXARIFE;
        }

        widget.container.getWidget('Produtos').enabled = false;
        Ajuste_Service.getOperadorLogado().then(function(operador) {
            widget.currentRow.NMOPERADOR = operador[0].NMOPERADOR;
            widget.currentRow.CDOPERADOR = operador[0].CDOPERADOR;
            widget.currentRow.CDFILIAL = operador[0].CDFILIALSELECIONADA;
            widget.currentRow.CDFILIMOVI = widget.appliedFilter.FILTER_ROW.CDFILIAL;
            widget.currentRow.IDORDEMCLC = Ajuste_Service.idOrdAjuInv == 'P' ? '0' : 'U';

            this.getDtprocessa(operador[0].CDFILIALSELECIONADA).then(function(DTPROCESSA) {
                widget.currentRow.DTLANCESTQ = (DTPROCESSA) ? DTPROCESSA : moment().format('DD/MM/YYYY');
            });
        }.bind(this));
    };

    this.newItem = function(widget) {
        var ordem = Ajuste_Service.idOrdAjuInv == 'P' ? '0' : 'U';
        var row = widget.dataSource.data[0];
        if (!row || !row.IDORDEMCLC || row.IDORDEMCLC == ordem) {
            widget.newRow();
            widget.currentRow.IDTIPOMOVI = widget.currentRow.IDTIPOMOVI == 0 ? '0' : '1';
            widget.getAction('viewstock').isVisible = false;
            
            if (widget.currentRow.IDTIPOMOVI == null)
                widget.currentRow.IDTIPOMOVI = '1';

            if (!almoxarifeFilter) {
                if (General.getFieldValue('CDALMOXARIFE', 'est42000_implantacao_estoque'))
                    widget.currentRow.CDALMOXARIFE = General.getFieldValue('CDALMOXARIFE', 'est42000_implantacao_estoque');
            }
            else {
                widget.currentRow.CDALMOXARIFE = almoxarifeFilter;
            }

            if (!localEstoqueFilter) {
                if (General.getFieldValue('CDLOCALESTOQ', 'est42000_implantacao_estoque'))
                    widget.currentRow.CDLOCALESTOQ = General.getFieldValue('CDLOCALESTOQ', 'est42000_implantacao_estoque');
            }
            else {
                widget.currentRow.CDLOCALESTOQ = localEstoqueFilter;
            }




        }
        else if (row.IDORDEMCLC != ordem) {
            MessageService.showMessageByCode("ORDEM_ATUALIZACAO");
        }
        else {
            MessageService.showMessageByCode("ERRO_NEW_ITEM");
        }
    };

    this.confirmDeleteItem = function(widget) {
        var deleteFunction = this.deleteItem.bind(this, widget);
        var row = widget.getParent().currentRow;
        let rowItem = widget.currentRow;
        if (rowItem.IDPERMEXCITINVE != 'N' || rowItem.IDAJUSTEIMPORT != 'S') {
            if (!widget.currentRow.__is_new) {
                ValidacoesEstoque_Service.validaDataLancamento(row.CDFILIMOVI, row.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(
                    function(success) {
                        ScreenService.confirmMessage('Excluir registro?', 'question', deleteFunction);
                    },
                    function(error) {
                        ScreenService.showMessage(error.data.error);
                    }
                );
            }
            else {
                widget.dataSource.data = widget.dataSource.data.filter(rows => {
                    if (rows != rowItem)
                        return true;
                    else
                        return false;
                });
                widget.currentRow = {};
                ScreenService.closeSwipe();
            }
        }
        else {

            ScreenService.showMessage('Não é permitido a exclusão de itens gerados por importação');
        }
    };

    this.getParamsImpEst = function(CDFILIMOVI) {
        return new Promise((resolve) => {
            General.callRestEngine('est_ajuste#/crud/paramimpest_params_codebar', 'FilterData', []).then(paramsData => {
                let hasDefaultParams = paramsData.dataset.paramimpest_params_codebar.filter(row => {
                    return row.IDFILIPADIMPEST == 'S';
                });

                if (hasDefaultParams.length == 0) {
                    return resolve(
                        paramsData.dataset.paramimpest_params_codebar.filter(row => {
                            return row.CDFILPARIMPEST === CDFILIMOVI;
                        })
                    );
                }
                else {
                    return resolve(hasDefaultParams);
                }
            });
        });

    };

    this.confirmDeleteLanc = function(widget) {
        var deleteFunction = this.deleteLancamento.bind(this, widget);
        var row = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);
        ScreenService.showLoader();
        ValidacoesEstoque_Service.validaDataLancamento(row.CDFILIMOVI, row.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(
            function(success) {
                ScreenService.hideLoader();
                ScreenService.confirmMessage('Excluir registro?', 'question', deleteFunction);
            },
            function(error) {
                ScreenService.showMessage(error.data.error);
                ScreenService.hideLoader();
            }
        );
    };

    this.deleteItem = function(widget) {
        if (widget.dataSource.data.length > 1) {
            var row = {};
            Util.extend(row, widget.currentRow);
            delete row.__rightActions;
            Ajuste_Service.deleteItem(row).then(function(success) {
                ScreenService.closeSwipe();
                widget.reload();
                widget.list();
            }, function(error) {
                ScreenService.showMessage(error.data.error);
            });
        }
        else {
            ScreenService.showMessage('É necessário ao menos um produto no lançamento!');
        }

    };

    this.deleteLancamento = function(widget) {
        var lancamento = Util.clone(widget.currentRow, ['__rightActions', '__leftActions']);
        var promises = [];
        ScreenService.showLoader();
        Ajuste_Service.deleteLancamento(lancamento).then(function() {
            ScreenService.showMessage("Lançamento excluido com sucesso");
            ScreenService.closeSwipe();
            widget.list();
            ScreenService.hideLoader();
            widget.reload();
        }, function(error) {
            ScreenService.showMessage(error.data.error);
            ScreenService.hideLoader();
        });
    };

    this.atualizaEstoque = function(widgetLancamento) {
        var row = widgetLancamento.currentRow;
        var widgetItems = widgetLancamento.container.getWidget('Produtos');

        var notSaved = widgetItems.dataSource.data.some(row => {
            return row.__is_new == true;
        });
        if (notSaved) {
            this.saveImport(widgetItems);
        }
        else {
            ValidacoesEstoque_Service.validaDataLancamento(row.CDFILIMOVI, row.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(
                function(success) {
                    if (widgetLancamento.container.getWidget('Produtos').dataSource.data.length > 0) {
                        let popUpRetirada = widgetLancamento.container.getWidget('PopUpRetiradaAjuste');
                        var popUpRetiradaPromisse = ZHPromise.defer();
                        if (widgetLancamento.container.name == 'est41000_ajuste_inventario' && widgetLancamento.appliedFilter.FILTER_ROW.IDGERARETAJU == 'S') { //aqui mudar para 'S'
                            Ajuste_Service.alreadyHasRetirada(widgetLancamento.currentRow).then(dataSetRetirada => {
                                let boolRetirada = dataSetRetirada.dataset.confereRetiradaAjuste.length > 0;
                                if (!boolRetirada) {
                                    widgetLancamento.currentRow.RETIESTQ = 'S';
                                    popUpRetirada.promisse = popUpRetiradaPromisse;
                                    popUpRetirada.currentRow.TPRETIAJUSTE = 'E';
                                    ScreenService.openPopup(popUpRetirada);
                                }
                                else {
                                    widgetLancamento.currentRow.TPRETIAJUSTE = dataSetRetirada.dataset.confereRetiradaAjuste[0].RETIESTQ == 'N' ? 'E' : 'S';
                                    popUpRetirada.currentRow.TPRETIAJUSTE = dataSetRetirada.dataset.confereRetiradaAjuste[0].RETIESTQ == 'N' ? 'E' : 'S';
                                    widgetLancamento.currentRow.RETIESTQ = dataSetRetirada.dataset.confereRetiradaAjuste[0].RETIESTQ;
                                    widgetLancamento.currentRow.NRCARDAPIO = dataSetRetirada.dataset.confereRetiradaAjuste[0].NRCARDAPIO;
                                    widgetLancamento.currentRow.CDSERVFILI = dataSetRetirada.dataset.confereRetiradaAjuste[0].CDSERVFILI;
                                    popUpRetiradaPromisse.resolve();
                                }
                            });
                        }
                        else {
                            widgetLancamento.currentRow.TPRETIAJUSTE = 'Z';
                            if (!popUpRetirada) {
                                popUpRetirada = { currentRow: {} };
                                popUpRetirada.currentRow.TPRETIAJUSTE = 'Z';
                            }
                            popUpRetiradaPromisse.resolve();
                        }
                        popUpRetiradaPromisse.then(resolved => {
                            if (!popUpRetirada)
                                popUpRetirada = { currentRow: {} };
                            widgetLancamento.currentRow.TPRETIAJUSTE = widgetLancamento.currentRow.TPRETIAJUSTE ? widgetLancamento.currentRow.TPRETIAJUSTE : popUpRetirada.currentRow.TPRETIAJUSTE;
                            widgetLancamento.currentRow.CDSERVFILI = widgetLancamento.currentRow.CDSERVFILI ? widgetLancamento.currentRow.CDSERVFILI : popUpRetirada.currentRow.CDSERVFILI;
                            widgetLancamento.currentRow.CDTIPORETI = widgetLancamento.currentRow.CDTIPORETI ? widgetLancamento.currentRow.CDTIPORETI : popUpRetirada.currentRow.CDTIPORETI;
                            widgetLancamento.currentRow.CDCENTCUST = widgetLancamento.currentRow.CDCENTCUST ? widgetLancamento.currentRow.CDCENTCUST : popUpRetirada.currentRow.CDCENTCUST;
                            widgetLancamento.currentRow.CDSETOR = widgetLancamento.currentRow.CDSETOR ? widgetLancamento.currentRow.CDSETOR : popUpRetirada.currentRow.CDSETOR;
                            widgetLancamento.currentRow.RETIESTQ = popUpRetirada.currentRow.TPRETIAJUSTE == 'E' ? 'N' : 'S';

                            Ajuste_Service.questionConsolidaEmProdEstoque(widgetItems.dataSource.data).then(boolConsolidateToStock => {
                                let isImport = widgetItems.dataSource.data.some(row => row.IDAJUSTEIMPORT != null);
                                if (isImport) {
                                    importEstoqQuestion(widgetLancamento, boolConsolidateToStock);
                                }
                                else {
                                    defaultEstoqQuestion(widgetLancamento, boolConsolidateToStock);
                                }
                            });
                        });
                    }
                    else {
                        ScreenService.showMessage('Lance um produto antes de atualizar');

                        this.openNewRowOnProdutoGrid(widgetLancamento.widgets[0]);
                    }
                }.bind(this),
                function(error) {
                    ScreenService.showMessage(error.data.error);
                    ScreenService.hideLoader();
                }
            );
        }
    };

    var importEstoqQuestion = function(widgetLancamento, boolConsolidateToStock) {
        let importGroupCode = widgetLancamento.currentRow.CDGRUPPRODLCEST;
        var filter = [{
            "name": "CDGRUPPROD",
            "operator": "=",
            "value": importGroupCode
        }];
        return General.callRestEngine('est#/crud/grupprod', 'FilterData', filter).then(messageType => {
            if (!messageType.dataset.grupprod.length)
                return defaultEstoqQuestion(widgetLancamento, boolConsolidateToStock);
            else
                messageType = messageType.dataset.grupprod[0].IDMSGATUEST;

            if (messageType == "0")
                return defaultEstoqQuestion(widgetLancamento, boolConsolidateToStock);

            if (messageType == "1") {
                return ScreenService.showCustomDialog('Deseja atualizar o estoque? [Atualizar] para atualizar o estoque. [Voltar] para voltar para o lançamento', 'question', 'question', [{
                        label: ScreenService.i18n("Atualizar"),
                        "default": true,
                        code: () => gravarFunction(widgetLancamento, boolConsolidateToStock)
                    },
                    {
                        label: ScreenService.i18n("Voltar"),
                        code: () => {}
                    }
                ]);
            }
            if (messageType == "2") {
                return ScreenService.showCustomDialog('Deseja atualizar o estoque? [Atualizar] para atualizar o estoque. [Voltar] para voltar para o lançamento', 'question', 'question', [{
                        label: ScreenService.i18n("Atualizar"),
                        "default": true,
                        code: () => zerarFunction(widgetLancamento, boolConsolidateToStock)
                    },
                    {
                        label: ScreenService.i18n("Voltar"),
                        code: () => {}
                    }
                ]);
            }

        });
    };

    var defaultEstoqQuestion = function(widgetLancamento, boolConsolidateToStock) {
        ScreenService.showCustomDialog('[Gravar] para atualizar o estoque.[Zerar] para atualizar o estoque e zerar os demais produtos.[Continuar] para continuar o cadastramento.', 'question', 'question', [{
                label: ScreenService.i18n("Gravar"),
                "default": true,
                code: () => gravarFunction(widgetLancamento, boolConsolidateToStock)
            },
            {
                label: ScreenService.i18n("Zerar"),
                code: () => zerarFunction(widgetLancamento, boolConsolidateToStock)
            },
            {
                label: ScreenService.i18n("Continuar"),
                code: () => {}
            }
        ]);
    };

    var gravarFunction = function(widgetLancamento, boolConsolidateToStock) {
        let row = widgetLancamento.currentRow;
        ScreenService.showLoader();

        let functioGravar = 'atualizaEstoque';
        let paramsFunction = [row.CDFILIAL, row.NRLANCESTQ, boolConsolidateToStock];

        if (widgetLancamento.appliedFilter.FILTER_ROW.IDGERARETAJU == 'S' && widgetLancamento.container.name == 'est41000_ajuste_inventario') {
            functioGravar = 'atualizaEstoqueRetirada';
            paramsFunction.push(Util.clone(row, ignoredCloneKeys));
        }

        ValidacoesEstoque_Service[functioGravar].apply(this, paramsFunction).then(function() {
            ScreenService.showMessage('Estoque atualizado com sucesso');
            ScreenService.closeSwipe(0);
            ScreenService.hideLoader();
            widgetLancamento.reload();
        }, function(error) {
            if (error.dataset) {
                if (error.dataset.irregularProducts) {
                    let widgetProdutos = widgetLancamento.container.getWidget('Produtos');
                    widgetProdutos.itemsPerPage = 999999;
                    widgetProdutos.hasPagination = false;
                    widgetProdutos.reload().then(reloaded => {
                        let irregularProducts = error.dataset.irregularProducts;
                        let dados = widgetProdutos.dataSource.data;
                        dados.forEach((d, index) => {
                            if (irregularProducts[d.CDPRODMOVI]) {
                                d.IRREGULAR = true;
                            }
                        });
                        widgetProdutos.redraw();
                    });
                }
            }
            ScreenService.showMessage(error.data.error);
            ScreenService.hideLoader();
        });
    };

    var zerarFunction = function(widgetLancamento, boolConsolidateToStock) {
        let row = widgetLancamento.currentRow;
        ScreenService.showLoader();

        let functioZerar = 'zeraInventario';
        let paramsFunction = [row.CDFILIAL, row.NRLANCESTQ, Ajuste_Service.getIdordemclc(), boolConsolidateToStock];

        if (widgetLancamento.appliedFilter.FILTER_ROW.IDGERARETAJU == 'S' && widgetLancamento.container.name == 'est41000_ajuste_inventario') {
            functioZerar = 'zeraInventarioRetirada';
            paramsFunction.push(Util.clone(row, ignoredCloneKeys));
        }

        ValidacoesEstoque_Service[functioZerar].apply(this, paramsFunction).then(function() {
            ScreenService.showMessage('Estoque Zerado com sucesso');
            widgetLancamento.widgets[0].reload();
            ScreenService.hideLoader();
        }, function(error) {
            if (error.dataset) {
                if (error.dataset.irregularProducts) {
                    let widgetProdutos = widgetLancamento.container.getWidget('Produtos');
                    widgetProdutos.itemsPerPage = 999999;
                    widgetProdutos.hasPagination = false;
                    widgetProdutos.reload().then(reloaded => {
                        let irregularProducts = error.dataset.irregularProducts;
                        let dados = widgetProdutos.dataSource.data;
                        dados.forEach((d, index) => {
                            if (irregularProducts[d.CDPRODMOVI]) {
                                d.IRREGULAR = true;
                            }
                        });
                        widgetProdutos.redraw();
                    });
                }
            }
            ScreenService.showMessage(error.data.error);
            ScreenService.hideLoader();
        });
    };

    this.zerarEstoque = function(widgetLancamento) {
        var row = widgetLancamento.currentRow;
        var widgetItems = widgetLancamento.container.getWidget('Produtos');

        var notSaved = widgetItems.dataSource.data.some(row => {
            return row.__is_new == true;
        });
        if (notSaved) {
            this.saveImport(widgetItems);
        }
        else {
            ValidacoesEstoque_Service.validaDataLancamento(row.CDFILIMOVI, row.DTLANCESTQ, 'AJUSTE_IMP', 'EST', null).then(
                function(success) {
                    if (widgetLancamento.container.getWidget('Produtos').dataSource.data.length > 0) {
                        ScreenService.showCustomDialog('O estoque será atualizado e os demais produtos serão zerados. Deseja realizar esta operação ?', 'question', 'question', [{
                                label: ScreenService.i18n("Zerar"),
                                "default": true,
                                code: function() {
                                    ValidacoesEstoque_Service.zeraInventario(row.CDFILIAL, row.NRLANCESTQ, Ajuste_Service.getIdordemclc()).then(function() {
                                        ScreenService.showMessage('Estoque Zerado com sucesso');
                                        widgetLancamento.widgets[0].reload();
                                    }, function(error) {
                                        if (error.dataset) {
                                            if (error.dataset.irregularProducts) {
                                                let irregularProducts = error.dataset.irregularProducts;
                                                let dados = widgetLancamento.widgets[0].dataSource.data;
                                                dados.forEach((d, index) => {
                                                    if (irregularProducts[d.CDPRODMOVI]) {
                                                        d.IRREGULAR = true;
                                                    }
                                                });
                                                widgetLancamento.widgets[0].redraw();
                                            }
                                        }
                                        ScreenService.showMessage(error.data.error);
                                    });
                                }.bind(this)
                            },
                            {
                                label: ScreenService.i18n("Cancelar"),
                                code: function() {}
                            }
                        ]);
                        let quest = option == 'Zerar' ? 'O estoque será atualizado e os demais produtos serão zerados.' : 'O estoque será atualizado.';
                        ScreenService.showCustomDialog(quest + ' Deseja realizar esta operação ?', 'question', 'question', [{
                                label: ScreenService.i18n("Sim"),
                                default: true,
                                code: () => {
                                    if (option == "sdb") {
                                        ValidacoesEstoque_Service.atualizaEstoque(row.CDFILIAL, row.NRLANCESTQ).then(function() {
                                            ScreenService.showMessage('Estoque atualizado com sucesso');
                                            ScreenService.closeSwipe(0);
                                            widgetLancamento.reload();
                                        }, function(error) {
                                            if (error.dataset) {
                                                if (error.dataset.irregularProducts) {
                                                    let irregularProducts = error.dataset.irregularProducts;
                                                    let dados = widgetLancamento.widgets[0].dataSource.data;
                                                    dados.forEach((d, index) => {
                                                        if (irregularProducts[d.CDPRODMOVI]) {
                                                            d.IRREGULAR = true;
                                                        }
                                                    });
                                                    widgetLancamento.widgets[0].redraw();
                                                }
                                            }
                                            ScreenService.showMessage(error.data.error);
                                        });

                                    }
                                    else {
                                        ValidacoesEstoque_Service.zeraInventario(row.CDFILIAL, row.NRLANCESTQ, Ajuste_Service.getIdordemclc()).then(function() {
                                            ScreenService.showMessage('Estoque Zerado com sucesso');
                                            widgetLancamento.widgets[0].reload();
                                        }, function(error) {
                                            if (error.dataset) {
                                                if (error.dataset.irregularProducts) {
                                                    let irregularProducts = error.dataset.irregularProducts;
                                                    let dados = widgetLancamento.widgets[0].dataSource.data;
                                                    dados.forEach((d, index) => {
                                                        if (irregularProducts[d.CDPRODMOVI]) {
                                                            d.IRREGULAR = true;
                                                        }
                                                    });
                                                    widgetLancamento.widgets[0].redraw();
                                                }
                                            }
                                            ScreenService.showMessage(error.data.error);
                                        });
                                    }
                                }
                            },
                            {
                                label: ScreenService.i18n("Não"),
                                code: () => {}
                            }
                        ]);



                    }
                    else {
                        ScreenService.showMessage('Lance um produto antes de atualizar');
                        ScreenService.closePopup(true);
                        this.openNewRowOnProdutoGrid(widgetLancamento.widgets[0]);
                    }
                }.bind(this),
                function(error) {
                    ScreenService.showMessage(error.data.error);

                }
            );
        }
        ScreenService.closePopup();
    };

    this.setVrBruto = function(row) {
        if (templateManager.container.getActiveWidget().mode === 'edit') {
            row.VRUNITBRUT = row.VRUNILANCTO;
            row.VRUNITBRUT_inline = row.VRUNILANCTO_inline;
        }
    };

    this.setVrBrutoChecking = function(row) {
        var widget = templateManager.container.getActiveWidget();
        if (row.__is_new && widget.mode === 'edit') {
            if (row.VRUNILANCTO_inline) {
                row.VRUNILANCTO = row.VRUNILANCTO_inline;
            }
            row.VRUNITBRUT = row.VRUNILANCTO;
            var valorPraUsar = row.VRUNILANCTO_inline || row.VRUNILANCTO;
            var fieldElement = widget.getField("VRUNITBRUT").element;
            fieldElement = $("#VRUNITBRUT");
            fieldElement.text(valorPraUsar);
            fieldElement.val(Util.applyMask(valorPraUsar, widget.getField("VRUNITBRUT").mask, maskEngine, ZhUtil));
        }

    };

    this.setCustoItem = function(widgetItem) {
        var rowAjuste = widgetItem.getParent().currentRow;
        var rowItem = widgetItem.currentRow;
        var fieldLiq = widgetItem.getField('VRUNILANCTO');
        var fieldBrut = widgetItem.getField('VRUNITBRUT');
        var almox = ' ';
        var local = ' ';
        var lote = ' ';
        var sublote = ' ';
        var tipoCustoLiq = Ajuste_Service.idTipoCustoLiq;
        var tipoCustoBrut = Ajuste_Service.idTipoCustoBrut;

        var fnLiq = ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(rowAjuste.CDFILIAL, rowItem.CDPRODUTO, rowAjuste.DTLANCESTQ, tipoCustoLiq, almox, local, lote, sublote);
        var fnBrut = ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(rowAjuste.CDFILIAL, rowItem.CDPRODUTO, rowAjuste.DTLANCESTQ, tipoCustoBrut, almox, local, lote, sublote);
        ZHPromise.all([fnLiq, fnBrut]).then(function(data) {
            var vrLiq = data[0].dataset.consultaCustoQuantidadeProduto.VRCUSTOPROD;
            var vrBrut = data[1].dataset.consultaCustoQuantidadeProduto.VRCUSTOPROD;
            if (vrLiq > 0 && vrBrut > 0) {
                var params = Util.extend(Util.clone(fieldBrut.mask.params), { showSymbol: true, symbol: "R$" }, true);
                var stringVrLiq = $.currency.string(vrLiq, params);
                var stringVrBrut = $.currency.string(vrBrut, params);
                var mensagens = {
                    "vrLiq": stringVrLiq,
                    "vrBrut": stringVrBrut
                };
                // ScreenService.confirmMessage('Último custo de movimentação estoque: Líquido - __vrLiq__ - Bruto - __vrBrut__. Deseja utilizá-lo?',undefined,function(){
                //     rowItem.VRUNITBRUT = vrLiq;
                //     rowItem.VRUNILANCTO = vrBrut;
                // }.bind(this),undefined,undefined,mensagens);

                var variaveis = {
                    vrLiq: stringVrLiq,
                    vrBrut: stringVrBrut
                };

                MessageService.confirmMessageByCode("ULTIMOCUSTOMOVEST", variaveis).then(function() {
                    rowItem.VRUNITBRUT = vrLiq;
                    rowItem.VRUNILANCTO = vrBrut;
                }.bind(this));
            }
        });
    };

    this.backAjusteLancto = function(args) {
        var widget = args.owner.widget.container.widgets[0];
        if (widget.currentRow.__is_new) {
            widget.reload();
        }
        General.backOrCancel(args);
    };

    this.backAjusteItem = function(args) {
        var widget = args.owner.widget;
        if (widget.currentRow.__is_new) {
            General.backOrCancel(args);
        }
        else {
            widget.list();
            widget.rollbackInlineEdit();
        }
    };

    this.validaFilialControlaEstoque = function(args) {
        if (this.validaFilial) {
            args.e.preventDefault();
            Ajuste_Service.filialControlEstq().then(
                function() {
                    this.validaFilial = false;
                    ScreenService.openWindow('est_ajuste#' + args.owner.name);
                }.bind(this),
                function(error) {
                    ScreenService.showMessage(error);
                }
            );
        }
        else {
            this.validaFilial = true;
        }
    };

    this.openPosicaoDeEstoque = function(widget) {
        ValidacoesEstoque_Service.openPosicaoDeEstoque(widget);
    };

    this.habilitaCamposImportacao = function(widget) {
        let origem = widget.getField("IDGRUPPROD");
        let GRUPPROD = widget.getField("NMGRUPPROD");
        if (widget.getField("AJUSTEPOR").value() === "P") {
            widget.label = "Importação de Produtos por Grupo";
            origem.isVisible = true;
            GRUPPROD.isVisible = true;
        }
        else {
            widget.label = "Ajuste Por Filial";
            origem.isVisible = false;
            GRUPPROD.isVisible = false;
        }
        widget.reload();
    };

    this.confirmarAjuste = function(widget) {
        if (widget.dataSource.data[0].hasOwnProperty('ajusteValido')) {
            if (widget.dataSource.data[0].ajusteValido === false) {
                ScreenService.closePopup();
                widget.promisse.reject();
                widget.dataSource.data = [];
                ScreenService.showMessage('Quantidade informada fora do Permitido');

            }
            else {
                ScreenService.closePopup();
                widget.promisse.resolve();
                widget.dataSource.data = [];
            }
        }
        else {
            ScreenService.closePopup();
            widget.promisse.resolve();
            widget.dataSource.data = [];
        }

    };

    this.validaCusto = function(rowCusto, row) {
        let rowItem = rowCusto.item;
        let valrAnte = rowCusto.valrAnte * rowItem.VRFATOCONV;
        let qtdeAnte = rowCusto.qtdeAnte;
        let valrMedi = rowCusto.valrMedi * rowItem.VRFATOCONV;
        let qtdeAtu = rowItem.QTTOTLANCTO;
        let valrAtu = valrMedi * qtdeAtu;

        if (rowItem.VRPTOLAJUSINV > 0 && rowItem.VRPTOLAJUSINV != null) {
            if (valrAnte * rowItem.VRFATOCONV != 0) {
                if (Math.abs(((valrMedi * qtdeAtu * rowItem.VRFATOCONV * 100) / valrAnte * rowItem.VRFATOCONV) - 100) > rowItem.VRFATOCONV) {
                    row.qntValida = false;
                    return false;
                }
            }
        }
        row.qntValida = true;
        return true;



    };

    this.emissaoAjuste = function(widget) {
        let ajusteRow = widget.currentRow;
        ScreenService.showLoader();
        ScreenService.openWindow("est_relatorios#est45000_emissao_inventario").then(opened => {
            let timeOutTime = 10; //time in seconds
            let recallTimes = 0;
            var autoFilter = setInterval(filterTimeout => {
                let widgetFilter = templateManager.container.getActiveWidget();
                if (widgetFilter.name == 'zhFilterPreferencesSelectConditions') {
                    clearInterval(autoFilter);
                    widgetFilter.currentRow.CDFILIAL = ajusteRow.CDFILIAL;
                    widgetFilter.currentRow.NMFILIAL = ajusteRow.NMFILIAL;
                    widgetFilter.currentRow.DTLANCESTQ = ajusteRow.DTLANCESTQ;
                    widgetFilter.currentRow.NRLANCESTQ = ajusteRow.NRLANCESTQ;
                    widgetFilter.currentRow.CDFILIMOVI = ajusteRow.CDFILIMOVI;
                    widgetFilter.currentRow.CDFILLANC = ajusteRow.CDFILIAL;
                    widgetFilter.getField('DTLANCESTQ').element.click();
                    widgetFilter.getField('NRLANCESTQ').element.click();
                    var widgetRelatorio = templateManager.container.getWidget('EmissaoInventarioGrid');
                    if (widgetFilter.getField('DTLANCESTQ') != "") {
                        widgetRelatorio.dataSource.name = "est_relatorios#/crud/itlanctoest_produto";
                    }
                    else {
                        widgetRelatorio.dataSource.name = "est_relatorios#/produto_posestatu_paramfilial";
                    }
                    widgetRelatorio.getAction('Voltar').isVisible = true;
                    //setReturnAction(widgetRelatorio);
                    widgetFilter.fields.forEach(f => {
                        if (f.validations)
                            delete f.validations;
                    });
                    setTimeout(time => {
                        widgetFilter.getAction('never').element.click();
                        ScreenService.hideLoader();
                    }, 1000);
                }
                else {
                    recallTimes++;
                    if (recallTimes == timeOutTime) {
                        clearInterval(autoFilter);
                        ScreenService.goBack();
                        ScreenService.hideLoader();
                    }
                }

            }, 1000);
        });
    };

    var setReturnAction = function(widget) {
        var actionGoBack = {
            name: 'back',
            label: 'Voltar',
            showAsAction: 'back_view|back_list',
            isVisible: true,
            showOnList: true,
            events: [{
                name: 'ActionEvent',
                code: 'ScreenService.goBack();',
            }]
        };
        actionGoBack = metaDataFactory.actionFactory(actionGoBack);
        actionGoBack.widget = widget;
        widget.actions.push(actionGoBack);
    };

    this.validaCorAlternada = function(indicerow) {
        if (indicerow % 2 != 0) {
            return false;
        }
        else {
            return true;
        }
    };

    this.controlaIndiceRow = function(widget) {
        var data = widget.dataSource.data;
        data.forEach(function(item, indice) {
            data[indice].INDICEROW = indice;
        });
    };

    this.setStripeData = function(widget) {
        let widgetStripe = widget.container.getWidget('stripeFooter');
        widgetStripe.currentRow.CDALMOXARIFE = widget.currentRow.CDALMOXARIFE;
        widgetStripe.currentRow.CDLOCALESTOQ = widget.currentRow.CDLOCALESTOQ;
        widgetStripe.currentRow.NRLOTEESTQ = widget.currentRow.NRLOTEESTQ;
        widgetStripe.currentRow.NRSUBLOTE = widget.currentRow.NRSUBLOTE;
    };

    this.validaCtrlLoteDtvalidade = function(widget) {
        let hasDtlote = !!widget.currentRow.DTVALILOTE;
        if (filutlote == 'S' && !hasDtlote) {
            this.openLibPopup(widget);
        }
    };

    this.processBeforeReport = function(widget) {
        widget.dataSourceFilter.forEach(filter => bkpDatasourceFilter.push(Util.clone(filter)));
        widget.afterOpenreport = () => {
            widget.dataSourceFilter = bkpDatasourceFilter;
        };
    };

    this.sugestProductCosts = function(widget) {
        ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(
            widget.currentRow.CDFILIMOVI,
            widget.currentRow.CDPRODUTO,
            widget.getParent().currentRow.DTLANCESTQ, //somente os 3 primeiros parametros sao obrigatórios
            null, //tipocusto null para pegar do parametro de estoque
            widget.currentRow.CDALMOXARIFE,
            widget.currentRow.CDLOCALESTOQ,
            widget.currentRow.NRLOTEESTQ,
            widget.currentRow.NRSUBLOTE
        ).then((success) => {
            if (success.dataset) {
                let custos = success.dataset.consultaCustoQuantidadeProduto;
                ScreenService.confirmMessage('Último custo de movimentação estoque: Líquido R$' + custos.VRCUSTOPRODLIQ + ' - Bruto R$' + custos.VRCUSTOPRODBRUT + '. Deseja utilizá-lo??', 'question', function() {
                    widget.currentRow.VRUNILANCTO = custos.VRCUSTOPRODLIQ;
                    widget.currentRow.VRUNITBRUT = custos.VRCUSTOPRODBRUT;
                }.bind(this));
            }
        });

    };

    this.changeTipoRetirada = function(widget) {
        if (widget.currentRow.TPRETIAJUSTE == 'E') {
            widget.getField('NMSERVICO').validations = { "required": true };
            widget.getField('NMSERVICO').isVisible = true;
            widget.getField('NMSETOR').isVisible = false;
            delete widget.getField('NMSETOR').validations;
            widget.currentRow.CDSETOR = '';
            widget.currentRow.NMSETOR = '';
            templateManager.updateTemplate();
        }
        else {
            widget.getField('NMSETOR').validations = { "required": true };
            widget.getField('NMSETOR').isVisible = true;
            widget.getField('NMSERVICO').isVisible = false;
            delete widget.getField('NMSERVICO').validations;
            widget.currentRow.CDSERVFILI = '';
            widget.currentRow.NMSERVICO = '';
            templateManager.updateTemplate();
        }
    };

    this.outDataPopupRetirada = function(popUpRetirada) {
        let widgetLancamento = popUpRetirada.container.getWidget('est41000_ajusteInventario');
        Object.assign(widgetLancamento.currentRow, popUpRetirada.currentRow);
    };

    this.validaProdutoPRetirada = function(widget) {
        /* Ajuste_Service.validaProdutoPRetirada(widget.currentRow.CDTIPORETI).then(result => {
             if (result.dataset.prodreti.length == 0) {
                 widget.currentRow.CDTIPORETI = '';
                 widget.currentRow.NMTIPORETI = '';
                 MessageService.showMessageByCode('DONT_EXISTS_PRODUCTS_RETIRADA');
             }
         }); */
    };

    this.validaAllProdutosPRetirada = function(popUpRetirada) {
        let widgetProdutos = popUpRetirada.container.getWidget('Produtos');
        if (popUpRetirada.currentRow.TPRETIAJUSTE == 'T' && !popUpRetirada.currentRow.CDCENTCUST) {
            MessageService.showMessageByCode('SETOR_WO_CENTCUST');
            return;
        }
        widgetProdutos.dataSource.load(widgetProdutos.getDataSourceFilter(), 'load_all').then(loaded => {
            let arrArvProd = [];
            loaded.dataset.itlanctoest_produto.forEach(row => {
                arrArvProd.push(row.CDARVPROD);
            });
            Ajuste_Service.validaAllProdutosPRetirada(arrArvProd, popUpRetirada.currentRow.CDTIPORETI).then(result => {
                let arrProdReti = [];
                result.dataset.produto_prodreti.forEach(row => {
                    arrProdReti.push(row.CDARVPROD);
                });
                let difference = arrArvProd.filter(prods => !arrProdReti.includes(prods));
                widgetProdutos.dataSource.data.forEach((row, index, array) => {
                    if (difference.includes(row.CDARVPROD))
                        array[index].IRREGULAR = true;
                });
                if (difference.length > 0) {
                    MessageService.showMessageByCode('DONT_EXISTS_PRODUCTS_RETIRADA');
                    popUpRetirada.promisse.reject();
                    ScreenService.closePopup();
                    widgetProdutos.redraw();
                    return;
                }

                this.outDataPopupRetirada(popUpRetirada);
                popUpRetirada.promisse.resolve();
                ScreenService.closePopup();
            });
        });
    };

    this.onManageXlsModelFields = function(isAjuste = true) {
        return new Promise((resolve, reject) => {

            const modelXlsWidget = templateManager.container.getWidget('modelWidget');
            const uploadWidget = templateManager.container.getWidget('wdgUpload');

            const almoxField = modelXlsWidget.getField('CDALMOXARIFE');
            const localField = modelXlsWidget.getField('CDLOCALESTOQ');
            const loteField = modelXlsWidget.getField('NRLOTEESTQ');
            const subLoteField = modelXlsWidget.getField('NRSUBLOTE');
            const priceField = modelXlsWidget.getField('VRUNILANCTO');
            const dtFabField = modelXlsWidget.getField('DTFABRPROD');
            const dtValiField = modelXlsWidget.getField('DTVALILOTE');
            const cdProdutoField = modelXlsWidget.getField('CDPRODUTO');
            const cdArvProdField = modelXlsWidget.getField('CDARVPROD');
            const cdBarProdField = modelXlsWidget.getField('CDBARPRODUTO');

            const codProdTypesVisibility = {
                'C': () => cdProdutoField.isVisible = true,
                'A': () => cdArvProdField.isVisible = true,
                'B': () => cdBarProdField.isVisible = true,
                notVisible: () => {
                    cdProdutoField.isVisible = false;
                    cdArvProdField.isVisible = false;
                    cdBarProdField.isVisible = false;
                }
            };
            const widgetName = isAjuste ? 'est41000_ajusteInventario' : 'est42000_implantacao_estoque';

            this.getParamsImpEst(EstUtil.getFieldValue('CDFILIAL', widgetName, true)).then(response => {
                if (response.length > 0) {
                    uploadWidget.currentRow.PARAMS = response[0];

                    codProdTypesVisibility.notVisible();
                    codProdTypesVisibility[response[0].IDTIPOPRODPAR]();

                    almoxField.isVisible = sessionStorage.getItem('IDUTILALMOX') == 'S' ? true : false;
                    localField.isVisible = sessionStorage.getItem('IDUTILLCESTQ') == 'S' ? true : false;
                    loteField.isVisible = sessionStorage.getItem('IDUTILLOTE') == 'S' ? true : false;
                    subLoteField.isVisible = sessionStorage.getItem('IDUTILLOTE') == 'S' ? true : false;

                    priceField.isVisible = isAjuste ? false : true;
                    dtFabField.isVisible = isAjuste ? false : true;
                    dtValiField.isVisible = isAjuste ? false : true;

                    templateManager.updateTemplate();
                    resolve(true);

                }
                else {
                    ScreenService.hideLoader();
                    ScreenService.showMessage("Parâmetros para importação de estoque não encontrados.");
                }
            }).catch(error => {
                if (error.data)
                    ScreenService.showMessage(error.data.error);
                else
                    ScreenService.showMessage(error);
                ScreenService.hideLoader();
                reject(false);
            });
        });
    };

    // This generates glossary fields
    this.buildGlossary = function(widget) {
        glossary = {
    
            "CDBARPRODUTO": {
                'desc': ScreenService.i18n('Código de Barras do produto'),
                'template': 'field/textarea.html',
                'textRows': 2
    
            },
            "CDARVPROD": {
                'desc': ScreenService.i18n('Código da Árvore de produto'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "CDPRODUTO": {
                'desc': ScreenService.i18n('Código do Produto'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "DTLANCESTQ": {
                'desc': ScreenService.i18n('Data de Lançamento de Estoque (DDMMYYYY)'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "QTTOTLANCTO": {
                'desc': ScreenService.i18n('Quantidade de Itens'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "VRUNILANCTO": {
                'desc': ScreenService.i18n('Valor Unitário'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "CDALMOXARIFE": {
                'desc': ScreenService.i18n('Código do Almoxarifado'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "CDLOCALESTOQ": {
                'desc': ScreenService.i18n('Código do Local de Estoque'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "NRLOTEESTQ": {
                'desc': ScreenService.i18n('Código do Lote'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "NRSUBLOTE": {
                'desc': ScreenService.i18n('Código do Sub Lote'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "DTFABRPROD": {
                'desc': ScreenService.i18n('Data de Fabricação do Produto (DDMMYYYY)'),
                'template': 'field/textarea.html',
                'textRows': 2
            },
            "DTVALILOTE": {
                'desc': ScreenService.i18n('Data de Validade de Lote (DDMMYYYY)'),
                'template': 'field/textarea.html',
                'textRows': 2
            }
        };
        const modelXlsWidget = templateManager.container.getWidget('modelWidget');

        modelXlsWidget.fields.forEach(field => {
            this.geraFields(field, widget).then(() => {
                this.setaFields(field, widget);
            });
        });
    };

    this.geraFields = function(field, widget) {
        var deferred = ZHPromise.defer();

        field = {
            "name": field.name,
            "label": field.name,
            "template": "field/text-edit.html",
            "isVisible": true,
            "showOnList": false,
            "showOnForm": true,
            "showOnView": false,
            "readOnly": true,
            "filterProperties": {
                "isVisible": false,
                "showOnForm": false
            }
        };

        metaDataFactory.fieldFactory(field, widget, widget);

        deferred.resolve();
        return deferred.promise;
    };

    this.setaFields = function(field, widget) {
        var deferred = ZHPromise.defer();

        if (glossary.hasOwnProperty(field.name))
            widget.getField(field.name).setValue(glossary[field.name].desc);

        deferred.resolve();
        return deferred.promise;
    };

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ajuste_Controller', Ajuste_Controller);
});

//recommit
