function Est40000_MapasPoliciaCivil_Controller(ScreenService, General, templateManager, localStorageEngine) {

	//This function sets default values for especifcs fields
	this.onEnterScreen = function(widget) {
		const { currentRow } = widget;
		currentRow.NMRELATORIO = "EST40000";
		currentRow.CDTRIMESTRE = "1";
		widget.reload();
	};

	// It calls back to manage and generate BIRT report.
	this.generateReport = function(widget, format) {
		if (widget.isValid()) {
			const { currentRow } = widget;
			const { startDate, endDate } = this.getTrimesterDates(currentRow);
			currentRow.DTINICIAL = startDate;
			currentRow.DTFINAL = endDate;
			currentRow.__FORMAT = format;


			General.openReport("est_relatorios#/mapas_policia_civil", currentRow.NMRELATORIO, currentRow, true);
		}
	};

	//It gets first and last trimester date
	this.getTrimesterDates = function(row) {
		let { CDTRIMESTRE, CDANO } = row;
		let startDate, endDate = "";

		switch (CDTRIMESTRE) {
			case '1':
				startDate = new Date('01/01/' + CDANO);
				endDate = new Date('01/01/' + CDANO);
				endDate.setMonth(2);
				break;
			case '2':
				startDate = new Date('04/01/' + CDANO);
				endDate = new Date('04/01/' + CDANO);
				endDate.setMonth(5);
				break;
			case '3':
				startDate = new Date('07/01/' + CDANO);
				endDate = new Date('07/01/' + CDANO);
				endDate.setMonth(8);
				break;
			case '4':
				startDate = new Date('10/01/' + CDANO);
				endDate = new Date('10/01/' + CDANO);
				endDate.setMonth(11);
				break;
			default:
				break;
		}
		return {
			"startDate": moment(startDate).format('DD/MM/YYYY'),
			"endDate": moment(endDate).endOf('month').format('DD/MM/YYYY')
		};
	};

}

Configuration(function(ContextRegister) {
	ContextRegister.register('Est40000_MapasPoliciaCivil_Controller', Est40000_MapasPoliciaCivil_Controller);
});
