var Est46000_EmissaoAjusteInventario_Service = function(General, Est46000_EmissaoAjusteInventario_Repository, restEngine, ZHPromise) {
    
    this.requestReport = function(row) {
        row.CDARVPRODFIN = row.CDARVPRODFIN + "zzzzzzzzzzzzzzzzzzzz";
        row.CDARVPRODFIN = row.CDARVPRODFIN.substring(0, 20);
        if(row.REPORT_NAME === 'EST46000' || row.REPORT_NAME === 'EST46000_retirada') {
            row.IDLANCTO  = row.IDLANCTO || 3;
            row.CUSTOS    = row.CUSTOS || 1;
            row.ORDENANOME = row.ORDENA || 0;
        }
        return General.openReport("est_relatorios#/relatorioEmissaoAjuste", row.REPORT_NAME, row, true);
    };

    this.retornaParamUnidade = function(cdFilialOpcional) {
        var cdFilialFiltrada = cdFilialOpcional || "FILIAL_LOGADA";
        var filter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": cdFilialFiltrada
            }
        ];
        return restEngine.post("est#/crud/paramfilial", {
            "requestType": "FilterData",
            "filter": filter
        });
    };

    this.requestValidations = function(cdfilial) {
        var deferred = ZHPromise.defer();

        this.retornaParamUnidade(cdfilial).then(function(response){
            if(response.dataset.paramfilial) {
                var ret = Array();

                ret.IDUTILALMOX = (response.dataset.paramfilial[0].IDUTILALMOX == 'S')? true : false;
                ret.IDUTILLCESTQ = (response.dataset.paramfilial[0].IDUTILLCESTQ == 'S')? true : false;
                ret.IDUTILLOTE = (response.dataset.paramfilial[0].IDUTILLOTE == 'S')? true : false;
                
                deferred.resolve(ret);
            } else {
                deferred.reject({"error": {"message": "Request error."}});
            }
        });

        return deferred;
    };
};

Configuration(function(ContextRegister){
    ContextRegister.register('Est46000_EmissaoAjusteInventario_Service', Est46000_EmissaoAjusteInventario_Service);
    
});
