package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.AjusteInventarioFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.AjusteInventarioPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class AjusteDeInventarioTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    AjusteInventarioFlows ajusteInventarioFlows;
    AjusteInventarioPage ajusteInventarioPage;


    @Test(priority = 10,description = "Est-04")

    public void EfetuarAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioFlows = new AjusteInventarioFlows();
        ajusteInventarioPage = new AjusteInventarioPage();


        //ParameteresLançamento:
        String quantidade = "5";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descLote = "025/50";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";
        String valorEstoqueEsperado = "5";
        String valorUnitarioLancado = "0";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioFlows.adicionarAjusteIventario(quantidade, cmpDesc, descProduto, descAlmoxarifado, descLote);

        //Banco

        String numeroLancamento = ajusteInventarioPage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(valorEstoqueEsperado));
        String valorLancamentoTotalEstoque = ajusteInventarioPage.retornaNumeroLacamento();
        //Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
        Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque, "comparação entre o valor lançado e o valor que tem em estoque");
        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));//verifica o valor lançado no banco do valor unitario


    }


    @Test(priority = 11,description = "Est-05")
    public void EditarAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioFlows = new AjusteInventarioFlows();
        ajusteInventarioPage = new AjusteInventarioPage();


        //ParameteresLançamento:

        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";
        //Parameteres_Editar
        String quantidade2 = "2";
        String cmpDesc2 = "Deletar";
        String descProduto2 = "Ochsenbuillon Paste (Hela 7565810050001)";
        String descLote2 = "20013001";


        loginFlows.efetuarLogin();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioFlows.editarAjusteIventario(cmpDesc2, quantidade2, descProduto2, descAlmoxarifado, descLote2);
    }

    @Test(priority = 12,description = "Est-06")
    public void ExcluirAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioFlows = new AjusteInventarioFlows();
        ajusteInventarioPage = new AjusteInventarioPage();


        //ParameteresLançamento:

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioFlows.excluirAjusteIventario();
    }

    @Test(priority = 13,description = "Est-07")
    public void importarAjusteInventario() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        ajusteInventarioFlows = new AjusteInventarioFlows();
        ajusteInventarioPage = new AjusteInventarioPage();

        //Parameteres

        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descOperador = "Deivison"; //  Constuido o caminho para ser usado somente com esse nome.

        loginFlows.efetuarLogin();
        mainFlows.AcessandoAjusteInventario();
        ajusteInventarioFlows.aplicarFiltro(descUnidade, descOperador);
        ajusteInventarioFlows.importarAjusteInventario();

    }
}



