package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.PosicaoDeEstoqueFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.PosicaoDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import java.io.File;
import org.testng.annotations.Test;


public class PosicaoDeEstoqueTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    PosicaoDeEstoqueFlows posicaoDeEstoqueFlows;
    PosicaoDeEstoquePage posicaoDeEstoquePage;


    @Test (priority = 20,description = "Est-13")
    public void GerarPosicaoDeEstoqueGrid(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        posicaoDeEstoqueFlows = new PosicaoDeEstoqueFlows();
        posicaoDeEstoquePage = new PosicaoDeEstoquePage();


        //Parameteres_Lançamento:
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descTipoDeCusto = "Custo Médio Líquido Atual";
        String validarCusto = "Custo Médio Líquido Atual";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoPosicaoDeEstoque();
        posicaoDeEstoqueFlows.GerarPosicaoDeEstoqueGrid(descUnidade,descAlmoxarifado,descTipoDeCusto,descProduto);

        //validacao
        String valorLancado = posicaoDeEstoquePage.validarGrid();
        Assert.assertEquals(valorLancado,validarCusto, "Grid validado com sucesso!");
    }


    @Test(priority = 31,description = "Est-XX")
    public void GerarPosicaoDeEstoquePDF(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        posicaoDeEstoqueFlows = new PosicaoDeEstoqueFlows();
        posicaoDeEstoquePage = new PosicaoDeEstoquePage();


        //Parameteres_Lançamento:
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descTipoDeCusto = "Custo Médio Líquido Atual";
        String downloadPath = "/Users/Teknisa Software/Downloads";
        String nomeArquivo = "EST31100.pdf";




        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoPosicaoDeEstoque();
        posicaoDeEstoqueFlows.GerarPosicaoDeEstoquePDF(descUnidade,descAlmoxarifado,descTipoDeCusto,descProduto);

        //Validacao
         File arquivo = new File(downloadPath + File.separator + nomeArquivo);
         if(arquivo.exists()){
             System.out.println("Download Realizado com Sucesso");
         }else {
             System.out.println("Ocorreu alguma falha no download, verifique se o arquivo esta correto na pasta");
         }

    }
    @Test(priority = 0,description = "Est-XX")
    public void GerarPosicaoDeEstoqueXLSX(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        posicaoDeEstoqueFlows = new PosicaoDeEstoqueFlows();
        posicaoDeEstoquePage = new PosicaoDeEstoquePage();


        //Parameteres_Lançamento:
        String descProduto = "Hela Poultry Broth Paste Clear KG";
        String descAlmoxarifado = "HELA MATRIZ";
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String descTipoDeCusto = "Custo Médio Líquido Atual";
        String downloadPath = "/Users/Teknisa Software/Downloads";
        String nomeArquivo = "EST31100.xlsx";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoPosicaoDeEstoque();
        posicaoDeEstoqueFlows.GerarPosicaoDeEstoqueXLSX(descUnidade,descAlmoxarifado,descTipoDeCusto,descProduto);

        //validação de download
        File arquivo = new File(downloadPath + File.separator + nomeArquivo);
        if(arquivo.exists()){
            System.out.println("Download  Realizado com Sucesso");
        }else{
            System.out.println("Ocorreu alguma falha no download xlsx, verifique se o arquivo esta correto na pasta");
        }

    }

}
