package com.javaseleniumtemplate.tests.naocontrolaalmoxarifado;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.naocontrolaalmoxarifado.EntradaDeEstoqueNaoControlaAlmoxarifadoFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.naocontrolaalmoxarifado.EntradaDeEstoqueNaoControlaAlmoxarifadoPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;


public class EntradaDeEstoqueNaoControlaAlmoxarifadoTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    EntradaDeEstoqueNaoControlaAlmoxarifadoFlows entradaDeEstoqueNaoControlaAlmoxarifadoFlows;
    EntradaDeEstoqueNaoControlaAlmoxarifadoPage entradaDeEstoqueNaoControlaAlmoxarifadoPage;


    @Test(description = "Est-52")
    @Ignore
    public void EfetuarEntradaDeEstoque() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows = new EntradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoPage = new EntradaDeEstoqueNaoControlaAlmoxarifadoPage();

        //Parameteres_login:

        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA Nao Controla Almoxarifado";
        String valorUnitario = "1,2";
        String valorEstoqueEsperado = "18";
        String valorTotalEstoqueEsperado = "18";
        String valorUnitarioLancado = "1.2";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows.AdicionarEntradaEstoque(cmpDesc, descProduto, quantidade, descAlmoxarifado, DescCampoLote, valorUnitario);

        //Banco

        String numeroLancamento = entradaDeEstoqueNaoControlaAlmoxarifadoPage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(valorEstoqueEsperado));
        String valorLancamentoTotalEstoque = entradaDeEstoqueNaoControlaAlmoxarifadoPage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
        Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque, "comparação entre o valor lançado e o valor que tem em estoque");
        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));//verifica o valor lançado no banco do valor unitario


    }

    @Test(description = "Est-53")
    @Ignore
    public void EditarEntradaEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows = new EntradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoPage = new EntradaDeEstoqueNaoControlaAlmoxarifadoPage();


        //Parameteres

        String cmpDesc2 = "Deletar";
        String cmpProduto = "Hela Poultry Broth Paste Clear KG";
        String descCampoLote = "025/50";
        String quantidade = "2";
        String valorUnitario = "1.5";

        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows.EditarEntradaEstoque(cmpDesc2, cmpProduto,descCampoLote, valorUnitario,quantidade);

    }

    @Test(description = "Est-54")
    @Ignore
    public void ExcluirEntradaDeEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows = new EntradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoPage = new EntradaDeEstoqueNaoControlaAlmoxarifadoPage();


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTrocaUnidadeNaoControlaAlmoxarifado();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows.ExcluirEntradaDeEstoque();
    }


    @Test(description = "Est-00")
    @Ignore
    public void TesteBanco() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoFlows = new EntradaDeEstoqueNaoControlaAlmoxarifadoFlows();
        entradaDeEstoqueNaoControlaAlmoxarifadoPage = new EntradaDeEstoqueNaoControlaAlmoxarifadoPage();


        //Rotinas:

        //loginFlows.efetuarLogin();
        String ntlancestq = "0000007471";
        String teste = DBSteps.retornaValorUnitarioLancadoEstoque(ntlancestq);

        System.out.println(teste);

    }



}




